'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Alert = function (_React$Component) {
  _inherits(Alert, _React$Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).call(this, props));

    _this.typeEnum = {
      "info": "alert alert-info",
      "success": "alert alert-success",
      "warning": "alert alert-warning ",
      "error": "alert alert-error"
    };
    _this.state = { display: false };

    return _this;
  }

  _createClass(Alert, [{
    key: 'onClick',
    value: function onClick(e) {
      this.setState({
        display: true
      });
      this.props.onClick && this.props.onClick(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          remove = _props.remove,
          title = _props.title,
          icon = _props.icon,
          description = _props.description;
      var display = this.state.display;

      var className = this.typeEnum[type] || this.typeEnum["default"];
      var iconlg = void 0;
      if (description) {
        className = className + " alert-with-description";
        if (!icon) {
          className = className + " alert-no-icon";
        } else {

          iconlg = icon;
          icon = false;
        }
      }

      return _react2.default.createElement(
        'div',
        { className: className + (display ? " hide" : "") },
        icon ? _react2.default.createElement('span', { className: 'alert-icon-circle' }) : "",
        iconlg ? _react2.default.createElement('span', { className: 'alert-icon-circle-lg' }) : "",
        _react2.default.createElement(
          'span',
          { className: 'alert-message' },
          title
        ),
        description ? _react2.default.createElement(
          'p',
          { className: 'alert-description' },
          this.props.children
        ) : "",
        remove ? _react2.default.createElement('span', { className: 'alert-icon-close', onClick: this.onClick.bind(this) }) : null
      );
    }
  }]);

  return Alert;
}(_react2.default.Component);

Alert.propTypes = {
  type: _propTypes2.default.string,
  remove: _propTypes2.default.bool,
  icon: _propTypes2.default.bool,
  title: _propTypes2.default.string,
  description: _propTypes2.default.bool
};
exports.default = Alert;
//# sourceMappingURL=Alert.js.map