'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckBoxGroup = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckBox = function (_React$Component) {
  _inherits(CheckBox, _React$Component);

  function CheckBox(props) {
    _classCallCheck(this, CheckBox);

    var _this = _possibleConstructorReturn(this, (CheckBox.__proto__ || Object.getPrototypeOf(CheckBox)).call(this, props));

    _this.checked = props.checked;

    _this.changeValue = function (e) {
      _this.checked = e.currentTarget.checked;
      _this.setState({
        checked: _this.checked
      });
      _this.props.onChange && _this.props.onChange(_this.checked);
    };
    return _this;
  }

  _createClass(CheckBox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.checked !== undefined) {
        this.checked = props.checked;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          disabled = _props.disabled;


      return _react2.default.createElement(
        'label',
        { className: "checkbox-wrapper" + (disabled ? " checkbox-disabled" : "") },
        _react2.default.createElement('input', { type: 'checkbox', checked: this.checked, disabled: disabled,
          onChange: this.changeValue }),
        label
      );
    }
  }]);

  return CheckBox;
}(_react2.default.Component);

CheckBox.propTypes = {
  onChange: _propTypes2.default.func,
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  label: _propTypes2.default.string
};
exports.default = CheckBox;

var CheckBoxGroup = exports.CheckBoxGroup = function (_React$Component2) {
  _inherits(CheckBoxGroup, _React$Component2);

  function CheckBoxGroup(props) {
    _classCallCheck(this, CheckBoxGroup);

    var _this2 = _possibleConstructorReturn(this, (CheckBoxGroup.__proto__ || Object.getPrototypeOf(CheckBoxGroup)).call(this, props));

    _this2.checked = props.checked;

    _this2.changeValue = function (e, value) {
      var checked = e.currentTarget.checked;
      if (checked) {
        _this2.checked.push(value);
      } else {
        _this2.checked.splice(_this2.checked.indexOf(value), 1);
      }
      _this2.setState({
        checked: _this2.checked
      });
      _this2.props.onChange && _this2.props.onChange(_this2.checked);
    };
    return _this2;
  }

  _createClass(CheckBoxGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.checked !== undefined) {
        this.checked = props.checked;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          options = _props2.options,
          disabled = _props2.disabled;


      return _react2.default.createElement(
        'div',
        null,
        options.map(function (item, i) {
          return _react2.default.createElement(
            'label',
            { className: "checkbox-wrapper" + (disabled.indexOf(item.value) >= 0 ? " checkbox-disabled" : ""), key: i },
            _react2.default.createElement('input', { type: 'checkbox', checked: _this3.checked.indexOf(item.value) >= 0,
              disabled: disabled.indexOf(item.value) >= 0, ref: 'checkbox', onChange: function onChange(e) {
                _this3.changeValue(e, item.value);
              } }),
            item.label
          );
        })
      );
    }
  }]);

  return CheckBoxGroup;
}(_react2.default.Component);

CheckBoxGroup.defaultProps = {
  disabled: [],
  checked: [],
  options: []
};
CheckBoxGroup.propTypes = {
  onChange: _propTypes2.default.func,
  checked: _propTypes2.default.array,
  defaultChecked: _propTypes2.default.array,
  options: _propTypes2.default.array,
  disabled: _propTypes2.default.array
};
//# sourceMappingURL=CheckBox.js.map