'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import { listeners } from 'cluster';


var DatePicker = function (_Component) {
	_inherits(DatePicker, _Component);

	function DatePicker(props) {
		_classCallCheck(this, DatePicker);

		var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

		_this.date = props.defaultValue ? new Date(props.defaultValue.replace(/-/g, '/')) : new Date();
		_this.needOnchange = false; //通过这个参数判断onBlur是否要触发onchange事件
		_this.state = {
			isShowPicker: false,
			isShowTime: false,
			showYear: _this.date.getFullYear(),
			showMonth: _this.date.getMonth() + 1,
			showDay: _this.date.getDay(),
			selectedYear: 0,
			selectMonth: 0,
			selectedDay: 0,
			date: props.defaultValue ? (0, _moment2.default)(_this.date).format(_this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD') : ''
		};
		return _this;
	}

	_createClass(DatePicker, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			if (props.date) {
				this.date = new Date(props.date);
				this.setState({
					showYear: this.date.getFullYear(),
					showMonth: this.date.getMonth() + 1,
					showDay: this.date.getDay(),
					selectedYear: this.date.getFullYear(),
					selectMonth: this.date.getMonth() + 1,
					selectedDay: this.date.getDay(),
					date: (0, _moment2.default)(this.date).format(this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD')
				});
			}
		}
	}, {
		key: 'handleDisabledDate',
		value: function handleDisabledDate(year, month, day, style, func) {
			var monthMinus1 = month - 1 == 0 ? 12 : month - 1;
			var currentMillionSeconds = new Date().setFullYear(year, monthMinus1, day);
			if (func && func(currentMillionSeconds)) {
				style += " calendar-disabled-cell";
			}
			return style;
		}

		/*算某个月的总天数*/

	}, {
		key: 'getdaysinonemonth',
		value: function getdaysinonemonth(year, month) {
			month = parseInt(month, 10);
			var d = new Date(year, month, 0);
			return d.getDate();
		}

		/*算某个月的第一天是星期几*/

	}, {
		key: 'getfirstday',
		value: function getfirstday(year, month) {
			month = month - 1;
			var d = new Date(year, month, 1);
			return d.getDay();
		}
	}, {
		key: 'datePut',
		value: function datePut(year, month) {
			var _state = this.state,
			    selectedYear = _state.selectedYear,
			    selectedMonth = _state.selectedMonth,
			    selectedDay = _state.selectedDay;

			var prevMonth = month - 1 == 0 ? 12 : month - 1;
			var nextMonth = month == 12 ? 1 : month + 1;
			var firstDay = this.getfirstday(year, month),

			/*monthCount: 某个月的总天数*/
			monthCount = this.getdaysinonemonth(year, month),
			    preMonthCount = this.getdaysinonemonth(year, prevMonth);
			var now = new Date(),
			    nowYear = now.getFullYear(),
			    nowMonth = now.getMonth() + 1,
			    nowDay = now.getDate();
			var day = 1;
			var start = false;
			var html = [];
			for (var i = 1; i < 7; i++) {
				//下拉框的行数，共六行
				var td = [];
				if (i == 1 && firstDay != 7) {
					//上个月
					for (var k = firstDay - 1; k >= 0; k--) {
						var currentYear = prevMonth == 1 ? year - 1 : year;
						var style = 'calendar-cell calendar-last-month-cell';
						style = this.handleDisabledDate(currentYear, prevMonth, preMonthCount, style, this.props.disabledDate);
						td.unshift(_react2.default.createElement(
							'td',
							{ key: i + "-" + k, className: style, onMouseDown: this.selected.bind(this, year, month, preMonthCount, "prev", style) },
							_react2.default.createElement(
								'div',
								{ className: 'calendar-date' },
								preMonthCount
							)
						));
						preMonthCount--;
					}
				}
				for (var j = 0; j < 7; j++) {
					//下拉框每一行中有七天，从周日到周六
					if (i == 1 && !start) {
						//第一行 当前月第一天
						if (firstDay == 7 && j == 0 || firstDay == j) {
							var _style = "calendar-cell ";
							if (day == nowDay && month == nowMonth && year == nowYear) {
								_style += "calendar-today ";
							}
							if (day == selectedDay && month == selectedMonth && year == selectedYear) {
								_style += "calendar-selected-day ";
							}
							_style = this.handleDisabledDate(year, month, day, _style, this.props.disabledDate);
							td.push(_react2.default.createElement(
								'td',
								{ key: i + "-" + j, className: _style, onMouseDown: this.selected.bind(this, year, month, day, "this", _style) },
								_react2.default.createElement(
									'div',
									{ className: 'calendar-date' },
									day
								)
							));
							day++;
							start = true;
						}
					} else if (start && day <= monthCount) {
						//当前月
						var _style2 = "calendar-cell ";
						if (day == nowDay && month == nowMonth && year == nowYear) {
							_style2 += "calendar-today ";
						}
						if (day == selectedDay && month == selectedMonth && year == selectedYear) {
							_style2 += "calendar-selected-day ";
						}
						_style2 = this.handleDisabledDate(year, month, day, _style2, this.props.disabledDate);
						td.push(_react2.default.createElement(
							'td',
							{ key: i + "-" + j, className: _style2, onMouseDown: this.selected.bind(this, year, month, day, "this", _style2) },
							_react2.default.createElement(
								'div',
								{ className: 'calendar-date' },
								day
							)
						));
						day++;
					} else if (start && day > monthCount) {
						//当前月的下个月
						var _currentYear = month == 12 ? year + 1 : year;
						var _style3 = "calendar-cell calendar-last-month-cell";
						_style3 = this.handleDisabledDate(_currentYear, nextMonth, day - monthCount, _style3, this.props.disabledDate);
						td.push(_react2.default.createElement(
							'td',
							{ key: i + "-" + j, className: _style3, onMouseDown: this.selected.bind(this, year, month, day - monthCount, "next", _style3) },
							_react2.default.createElement(
								'div',
								{ className: 'calendar-date' },
								day - monthCount
							)
						));
						day++;
					}
				}
				html.push(_react2.default.createElement(
					'tr',
					{ key: html.length },
					td
				));
			}
			return html;
		}
	}, {
		key: 'getDataTable',
		value: function getDataTable() {
			var _this2 = this;

			var _state2 = this.state,
			    showYear = _state2.showYear,
			    showMonth = _state2.showMonth;

			var thead = [];
			var showTime = this.props.showTime;

			thead.push(_react2.default.createElement(
				'thead',
				{ key: thead.length },
				_react2.default.createElement(
					'tr',
					null,
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u65E5'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u4E00'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u4E8C'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u4E09'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u56DB'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u4E94'
						)
					),
					_react2.default.createElement(
						'th',
						{ className: 'calendar-column-header' },
						' ',
						_react2.default.createElement(
							'span',
							{ className: 'calendar-column-header-inner' },
							'\u516D'
						)
					)
				)
			));
			return _react2.default.createElement(
				'div',
				{ className: 'calendar-picker-panel' },
				_react2.default.createElement(
					'div',
					{ className: 'calendar-picker-date-panel' },
					_react2.default.createElement(
						'div',
						{ className: 'calendar-hearder' },
						_react2.default.createElement(
							'a',
							{ className: 'calendar-prev-year-btn', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.dateChange("year", "prev");
								} },
							' '
						),
						_react2.default.createElement(
							'a',
							{ className: 'calendar-prev-month-btn', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.dateChange("month", "prev");
								} },
							' '
						),
						_react2.default.createElement(
							'span',
							{ className: 'calendar-my-select' },
							_react2.default.createElement(
								'a',
								{ className: 'calendar-year-select txt-link' },
								showYear,
								'\u5E74'
							),
							_react2.default.createElement(
								'a',
								{ className: 'calendar-month-select txt-link' },
								showMonth,
								'\u6708'
							)
						),
						_react2.default.createElement(
							'a',
							{ className: 'calendar-next-month-btn', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.dateChange("month", "next");
								} },
							' '
						),
						_react2.default.createElement(
							'a',
							{ className: 'calendar-next-year-btn', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.dateChange("year", "next");
								} },
							' '
						)
					),
					_react2.default.createElement(
						'div',
						{ className: 'calendar-body' },
						_react2.default.createElement(
							'table',
							{ className: 'calendar-table' },
							thead,
							_react2.default.createElement(
								'tbody',
								{ className: 'calendar-tbody' },
								this.datePut(showYear, showMonth)
							)
						)
					),
					_react2.default.createElement(
						'div',
						{ className: 'calendar-footer' },
						_react2.default.createElement(
							'a',
							{ className: showTime ? 'calendar-moment-btn txt-link' : 'calendar-today-btn txt-link', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.today();
								} },
							'\u4ECA\u5929'
						),
						showTime ? _react2.default.createElement(
							'a',
							{ className: 'calendar-time-select-btn txt-link select-time', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this2.selectTime();
								} },
							'\u9009\u62E9\u65F6\u95F4'
						) : null
					)
				)
			);
		}
	}, {
		key: 'timeSelect',
		value: function timeSelect(type, value, e) {
			if (type == 'second') document.activeElement.blur();
			var date = this.state.date;

			this.date = (0, _moment2.default)(date)[type](value).format('YYYY-MM-DD HH:mm:ss');
			this.setState({
				date: (0, _moment2.default)(date)[type](value).format('YYYY-MM-DD HH:mm:ss'),
				isShowPicker: type == 'second' ? false : true,
				isShowTime: type == 'second' ? false : true
			});
		}
	}, {
		key: 'getTimeTable',
		value: function getTimeTable() {
			var _this3 = this;

			var date = this.state.date;

			var timeArr = ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59"];
			var hour = (0, _moment2.default)(date).hour();
			var minute = (0, _moment2.default)(date).minute();
			var second = (0, _moment2.default)(date).second();
			return _react2.default.createElement(
				'div',
				{ className: 'calendar-picker-panel', type: 'time', style: { height: '322px' } },
				_react2.default.createElement(
					'div',
					{ className: 'calendar-picker-date-panel' },
					_react2.default.createElement(
						'div',
						{ className: 'calendar-hearder' },
						date
					),
					_react2.default.createElement(
						'div',
						{ className: 'calendar-time' },
						_react2.default.createElement(
							'div',
							{ className: 'calendar-time-panel' },
							_react2.default.createElement(
								'div',
								{ className: 'time-picker-combobox-wrapper', onMouseDown: function onMouseDown(e) {
										e.preventDefault();
									} },
								_react2.default.createElement(
									'div',
									{ className: 'time-picker-select', type: 'hour' },
									_react2.default.createElement(
										'ul',
										null,
										timeArr.map(function (item) {
											return _react2.default.createElement(
												'li',
												{ className: item == hour ? 'item-action' : '', key: item, onClick: _this3.timeSelect.bind(_this3, 'hour', item) },
												item
											);
										})
									)
								),
								_react2.default.createElement(
									'div',
									{ className: 'time-picker-select', type: 'minute' },
									_react2.default.createElement(
										'ul',
										null,
										timeArr.map(function (item) {
											return _react2.default.createElement(
												'li',
												{ className: item == minute ? 'item-action' : '', key: item, onClick: _this3.timeSelect.bind(_this3, 'minute', item) },
												item
											);
										})
									)
								),
								_react2.default.createElement(
									'div',
									{ className: 'time-picker-select', type: 'second' },
									_react2.default.createElement(
										'ul',
										null,
										timeArr.map(function (item) {
											return _react2.default.createElement(
												'li',
												{ className: item == second ? 'item-action' : '', key: item, onClick: _this3.timeSelect.bind(_this3, 'second', item) },
												item
											);
										})
									)
								)
							)
						)
					),
					_react2.default.createElement(
						'div',
						{ className: 'calendar-footer' },
						_react2.default.createElement(
							'a',
							{ className: 'calendar-moment-btn txt-link', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									var date = _this3.state.date;

									date = (0, _moment2.default)(date).second((0, _moment2.default)().second());
									date = (0, _moment2.default)(date).minute((0, _moment2.default)().minute());
									date = (0, _moment2.default)(date).hour((0, _moment2.default)().hour());
									_this3.setState({
										date: date.format('YYYY-MM-DD HH:mm:ss')
									});
								} },
							'\u6B64\u523B'
						),
						_react2.default.createElement(
							'a',
							{ style: { marginLeft: '70px' }, className: 'txt-link select-date', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this3.setState({ isShowTime: false });
								} },
							'\u9009\u62E9\u65E5\u671F'
						),
						_react2.default.createElement(
							'a',
							{ style: { marginLeft: '10px' }, className: 'txt-link select-date', onMouseDown: function onMouseDown(e) {
									e.preventDefault();
									_this3.setState({ isShowTime: false, isShowPicker: false });
								} },
							'\u786E\u5B9A'
						)
					)
				)
			);
		}
		// show(){
		// 	var {isShowPicker} = this.state;
		// 	if(this.props.disabled){
		// 		return ;
		// 	}
		// 	this.setState({
		// 		isShowPicker: !isShowPicker
		// 	});
		// 	this.props.onOpenChange&&this.props.onOpenChange(!isShowPicker);
		// }

	}, {
		key: 'selected',
		value: function selected(year, month, day, type, style, e) {

			if (this.props.showTime) e.preventDefault();
			if (style.indexOf("calendar-disabled-cell") > 0) return false;
			var selectedYear, selectedMonth, selectedDay;
			if (type == "this") {
				selectedYear = year;
				selectedMonth = month;
				selectedDay = day;
			} else if (type == "prev") {
				selectedYear = month == 1 ? year - 1 : year;
				selectedMonth = month == 1 ? 12 : month - 1;
				selectedDay = day;
			} else if (type == "next") {
				selectedYear = month == 12 ? year + 1 : year;
				selectedMonth = month == 12 ? 1 : month + 1;
				selectedDay = day;
			}
			if (this.props.showTime) {
				this.date = new Date(selectedYear, selectedMonth - 1, selectedDay, new Date().getHours(), new Date().getMinutes(), new Date().getSeconds());
			} else {
				this.date = new Date(selectedYear, selectedMonth - 1, selectedDay);
			}
			this.setState({
				isShowTime: this.props.showTime,
				selectedYear: selectedYear,
				selectedMonth: selectedMonth,
				selectedDay: selectedDay,
				showYear: selectedYear,
				showMonth: selectedMonth,
				date: (0, _moment2.default)(this.date).format(this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD')
			});
		}
	}, {
		key: 'deleteTime',
		value: function deleteTime() {
			this.setState({
				selectedYear: 0,
				selectedMonth: 0,
				selectedDay: 0,
				date: ""
			});
			this.onChange();
		}
	}, {
		key: 'dateChange',
		value: function dateChange(type, direction) {
			var _state3 = this.state,
			    showYear = _state3.showYear,
			    showMonth = _state3.showMonth;

			var year, month;
			if (type == 'year' && direction == 'prev') {
				year = showYear - 1;
				month = showMonth;
			} else if (type == 'year' && direction == 'next') {
				year = showYear + 1;
				month = showMonth;
			} else if (type == 'month' && direction == 'prev') {
				year = showMonth == 1 ? showYear - 1 : showYear;
				month = showMonth == 1 ? 12 : showMonth - 1;
			} else if (type == 'month' && direction == 'next') {
				year = showMonth == 12 ? showYear + 1 : showYear;
				month = showMonth == 12 ? 1 : showMonth + 1;
			}
			this.setState({
				showYear: year,
				showMonth: month
			});
		}
	}, {
		key: 'today',
		value: function today() {
			var now = new Date(),
			    nowYear = now.getFullYear(),
			    nowMonth = now.getMonth() + 1,
			    nowDay = now.getDate();
			this.date = now;
			this.setState({
				showYear: nowYear,
				showMonth: nowMonth,
				showDay: nowDay,
				selectedDay: nowDay,
				selectedMonth: nowMonth,
				selectedYear: nowYear,
				date: (0, _moment2.default)(this.date).format(this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD')
			});
		}
	}, {
		key: 'selectTime',
		value: function selectTime() {
			this.setState({
				isShowTime: true
			});
		}
	}, {
		key: 'onChange',
		value: function onChange() {
			this.needOnchange = false;
			this.props.onChange && this.props.onChange(this.date);
		}
	}, {
		key: 'inputOnChange',
		value: function inputOnChange(e) {
			var date = this.refs.date.value;
			this.setState({
				date: date
			});
		}
	}, {
		key: 'onFocus',
		value: function onFocus() {
			//聚焦
			if (this.props.disabled) {
				return;
			}
			this.setState({
				isShowPicker: true
			});
			this.props.onOpenChange && this.props.onOpenChange(true);
		}
	}, {
		key: 'onBlur',
		value: function onBlur() {
			//失去焦点
			var date = this.state.date;

			if (new Date(date) != 'Invalid Date') {
				this.date = new Date(date);
				this.setState({
					showYear: this.date.getFullYear(),
					showMonth: this.date.getMonth() + 1,
					showDay: this.date.getDate(),
					selectedYear: this.date.getFullYear(),
					selectedMonth: this.date.getMonth() + 1,
					selectedDay: this.date.getDate(),
					date: (0, _moment2.default)(this.date).format(this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD')
				});
			}
			this.setState({
				date: (0, _moment2.default)(this.date).format(this.props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'),
				isShowPicker: false
			});
			this.props.onOpenChange && this.props.onOpenChange(false);
			this.onChange();
		}
	}, {
		key: 'onKeyDown',
		value: function onKeyDown(e) {
			// if(e.which == 13){
			// 	this.show()
			// }
			// this.needOnchange = true;

			this.props.onKeyDown && this.props.onKeyDown();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this4 = this;

			var _state4 = this.state,
			    isShowPicker = _state4.isShowPicker,
			    date = _state4.date,
			    isShowTime = _state4.isShowTime;

			var style = isShowPicker ? "calendar-picker  calendar-picker-action calendar-single-picker" : "calendar-picker  calendar-single-picker";
			style += this.props.disabled ? " calendar-picker-disabled" : "";
			style += this.props.showTime ? " calendar-time-picker" : "";
			return _react2.default.createElement(
				'div',
				{ className: style },
				_react2.default.createElement(
					'div',
					{ className: 'calendar-picker-input-wrapper' },
					_react2.default.createElement('input', { type: 'text', name: '', className: 'calendar-picker-input', placeholder: this.props.placeholder || "请选择时间", value: date,
						onChange: function onChange(e) {
							_this4.inputOnChange(e);
						},
						onBlur: function onBlur() {
							_this4.onBlur();
						},
						onKeyDown: function onKeyDown(e) {
							_this4.onKeyDown(e);
						},
						onFocus: function onFocus() {
							_this4.onFocus();
						},
						ref: 'date'
					}),
					_react2.default.createElement('span', { className: 'icon-calendar-picker', onMouseDown: function onMouseDown(e) {
							isShowPicker && e.preventDefault();
							isShowPicker && _this4.deleteTime();
						} })
				),
				isShowTime ? this.getTimeTable() : this.getDataTable()
			);
		}
	}]);

	return DatePicker;
}(_react.Component);

DatePicker.propTypes = {
	defaultValue: _propTypes2.default.string,
	disabled: _propTypes2.default.bool,
	showTime: _propTypes2.default.bool,
	disabledDate: _propTypes2.default.func,
	placeholder: _propTypes2.default.string,
	onChange: _propTypes2.default.func,
	onOpenChange: _propTypes2.default.func
};
exports.default = DatePicker;
//# sourceMappingURL=DatePicker.js.map