'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputNumber = function (_React$Component) {
  _inherits(InputNumber, _React$Component);

  function InputNumber(props) {
    _classCallCheck(this, InputNumber);

    var _this = _possibleConstructorReturn(this, (InputNumber.__proto__ || Object.getPrototypeOf(InputNumber)).call(this, props));

    var value = props.value;
    if (value === undefined && props.defaultValue !== undefined) {
      value = props.defaultValue;
    } else if (value === undefined) {
      value = null;
    }
    _this.state = {
      hover: false,
      value: value,
      preValue: value
    };
    _this.value = value;
    return _this;
  }

  _createClass(InputNumber, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.value !== undefined && props.value != this.value) {
        this.value = props.value;
        this.refs['input'].value = this.value;
        this.setState({
          value: this.value
        });
      }
    }
  }, {
    key: 'count',
    value: function count(type) {
      var _props = this.props,
          min = _props.min,
          max = _props.max,
          step = _props.step;

      step = parseInt(step || 1);
      var value = this.state.value || 0;

      value = parseInt(value);
      if (type == '+') {
        value = value + step;
      } else if (type == '-') {
        value = value - step;
      }

      if ((min || min === 0) && value < min) {
        value = min;
      }
      if (max && value > max) {
        value = max;
      }

      this.setState({
        value: value
      });
      this.value = value;
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      switch (e.key) {
        case '+':
        case 'ArrowUp':
          this.count('+');
          break;
        case '-':
        case 'ArrowDown':
          this.count('-');
          break;
      }
      this.props.onKeyDown && this.props.onKeyDown(e.which);
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      var value = this.refs['input'].value;
      value = this.getValue(value);
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'blur',
    value: function blur() {
      var value = this.getValue();
      this.props.onBlur && this.props.onBlur(value);
    }
  }, {
    key: 'getValue',
    value: function getValue(value) {
      if (value === undefined) {
        value = this.state.value;
      }

      var preValue = this.state.preValue;
      var _props2 = this.props,
          max = _props2.max,
          min = _props2.min;

      value = parseInt(value);

      if (isNaN(value)) {
        value = "";
      } else if ((min || min === 0) && value < min) {
        value = min;
        preValue = value;
      } else if (max && value > max) {
        value = max;
        preValue = value;
      } else {
        preValue = value;
      }
      this.setState({
        value: value,
        preValue: preValue
      });
      this.value = value;
      return value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          hover = _state.hover,
          value = _state.value;

      return _react2.default.createElement(
        'div',
        { className: 'number-control',
          onMouseOver: function onMouseOver() {
            _this2.setState({ hover: true });
          },
          onMouseLeave: function onMouseLeave() {
            _this2.setState({ hover: false });
          },
          onKeyDown: function onKeyDown(e) {
            _this2.onKeyDown(e);
          }
        },
        _react2.default.createElement('input', _extends({ type: 'text', ref: 'input', className: 'input-number'
        }, this.props, { value: value, onChange: function onChange(e) {
            _this2.onChange(e);
          },
          onBlur: function onBlur() {
            _this2.blur();
          }
        })),
        hover ? _react2.default.createElement(
          'div',
          { className: 'number-control-icon' },
          _react2.default.createElement('span', { className: 'number-control-icon-item icon-formup', onClick: function onClick() {
              _this2.count('+');
            } }),
          _react2.default.createElement('span', { className: 'number-control-icon-item icon-formdown', onClick: function onClick() {
              _this2.count('-');
            } })
        ) : null
      );
    }
  }]);

  return InputNumber;
}(_react2.default.Component);

InputNumber.defaultProps = {
  min: 0
};
InputNumber.propTypes = {
  disabled: _propTypes2.default.bool,
  defaultValue: _propTypes2.default.number,
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  step: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  value: _propTypes2.default.number
};
exports.default = InputNumber;
//# sourceMappingURL=InputNumber.js.map