'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Menu = function (_React$Component) {
  _inherits(Menu, _React$Component);

  function Menu(props) {
    _classCallCheck(this, Menu);

    var _this = _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).call(this, props));

    _this.state = {
      selectedKeys: props.selectedKeys || props.defaultSelectedKeys || [],
      openKeys: props.openKeys || props.defaultOpenKeys || []
    };
    return _this;
  }

  _createClass(Menu, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        selectedKeys: nextProps.selectedKeys || this.state.selectedKeys,
        openKeys: nextProps.openKeys || this.state.openKeys
      });
    }
  }, {
    key: 'onOpenKeys',
    value: function onOpenKeys(key, menu, e) {

      if (key) {
        var openKeys = this.state.openKeys.slice(0);
        if (openKeys.indexOf(key) != -1) {
          openKeys.splice(openKeys.indexOf(key), 1);
        } else {
          openKeys.push(key);
        }
        this.setState({
          openKeys: openKeys
        });
      }
    }
  }, {
    key: 'onSelectedKey',
    value: function onSelectedKey(key, menu, e) {
      if (key) {
        var selectedKeys = this.state.selectedKeys.slice(0);
        if (selectedKeys.indexOf(key) != -1) {
          selectedKeys.splice(selectedKeys.indexOf(key), 1);
        } else {
          selectedKeys = [key];
        }
        this.setState({
          selectedKeys: selectedKeys
        });
      }
      //调用 onSelect
      this.props.onSelect && this.props.onSelect(menu, e);
    }
  }, {
    key: 'renderItem',
    value: function renderItem(menu) {
      return _react2.default.createElement(
        'a',
        { href: menu.href || "javascript:;", onClick: menu.list ? this.onOpenKeys.bind(this, menu.key, menu) : this.onSelectedKey.bind(this, menu.key, menu) },
        menu.title,
        menu.list ? _react2.default.createElement('span', { className: 'icon-caret icon-caret-color' }) : null
      );
    }
  }, {
    key: 'renderSubItem',
    value: function renderSubItem(item, index) {
      var selectedKeys = this.state.selectedKeys;


      return _react2.default.createElement(
        'li',
        { className: selectedKeys.indexOf(item.key) != -1 ? "list-dropdown-item list-action" : "list-dropdown-item", key: index },
        _react2.default.createElement(
          'a',
          { href: item.href || "javascript:;", onClick: this.onSelectedKey.bind(this, item.key, item) },
          item.title
        )
      );
    }
    //判断grouplist的class

  }, {
    key: 'getListGroupClassName',
    value: function getListGroupClassName(menu) {
      var openKeys = this.state.openKeys;
      var selectedKeys = this.state.selectedKeys;
      var isChildList = !!(menu.list && menu.list.length);
      var isChecked = selectedKeys.indexOf(menu.key) != -1;

      if (isChildList && openKeys.indexOf(menu.key) != -1) {
        //(有子元素 && 被选中)
        return "list-group-item list-dropdown list-dropdown-action"; //展开菜单
      } else if (isChecked) {
        //没有子元素被选中
        return "list-group-item list-action";
      } else {
        return "list-group-item";
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var dataSource = this.props.dataSource;
      var openKeys = this.state.openKeys;
      //list-dropdown-action
      //list-action

      return _react2.default.createElement(
        'ul',
        { className: 'yt-list-group' },
        dataSource.map(function (menu, index) {
          return _react2.default.createElement(
            'li',
            {
              className: _this2.getListGroupClassName(menu),
              key: index
            },
            _this2.renderItem(menu),
            _react2.default.createElement(
              'ul',
              { className: 'dropdown-menu' },
              menu.list && menu.list.map(function (item, index) {
                return _this2.renderSubItem(item, index);
              })
            )
          );
        })
      );
    }
  }]);

  return Menu;
}(_react2.default.Component);

Menu.defaultProps = {
  multiple: false
};
Menu.propTypes = {
  /**
   {
      title:"main",
      href:"/main",
      key:"",
      list:[
        { 
          title:"sub",
          href:"sub",
          key:""
        }
      ]
   } 
  */
  dataSource: _propTypes2.default.array.isRequired,
  openKeys: _propTypes2.default.array,
  defaultOpenKeys: _propTypes2.default.array, //[key1,key2]
  selectedKeys: _propTypes2.default.array,
  defaultSelectedKeys: _propTypes2.default.array,
  onSelect: _propTypes2.default.func, //选中后的回调
  multiple: _propTypes2.default.bool
};
exports.default = Menu;
//# sourceMappingURL=Menu.js.map