'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GlobalMessage = function GlobalMessage(props) {
	var type = props.type,
	    content = props.content;

	return _react2.default.createElement(
		'div',
		{ className: 'message-notice' },
		_react2.default.createElement(
			'div',
			{ className: 'message-notice-content' },
			_react2.default.createElement('span', { className: "message-icon " + type }),
			_react2.default.createElement(
				'span',
				null,
				content
			)
		)
	);
};

GlobalMessage.propTypes = {
	type: _propTypes2.default.string.isRequired,
	content: _propTypes2.default.string.isRequired
};

var Message = function () {
	function Message() {
		_classCallCheck(this, Message);
	}

	_createClass(Message, null, [{
		key: 'success',
		value: function success(content, timeout, onClose) {
			this.message('pirosicon-solid-success', content, timeout, onClose);
		}
	}, {
		key: 'info',
		value: function info(content, timeout, onClose) {
			this.message('pirosicon-solid-info', content, timeout, onClose);
		}
	}, {
		key: 'warning',
		value: function warning(content, timeout, onClose) {
			this.message('pirosicon-solid-warning', content, timeout, onClose);
		}
	}, {
		key: 'error',
		value: function error(content, timeout, onClose) {
			this.message('pirosicon-solid-error', content, timeout, onClose);
		}
	}, {
		key: 'loading',
		value: function loading(content, timeout, onClose) {
			this.message('loading', content, timeout, onClose);
		}
	}, {
		key: 'message',
		value: function message(type, content) {
			var timeout = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 3000;
			var onClose = arguments[3];

			this.propTypes = {
				onClose: _propTypes2.default.func
			};
			var container = document.createElement('div');
			container.setAttribute('class', 'message message-action');
			document.body.appendChild(container);
			(0, _reactDom.render)(_react2.default.createElement(GlobalMessage, { type: type, content: content }), container);
			setTimeout(function () {
				(0, _reactDom.unmountComponentAtNode)(container);
				container.remove();
				onClose && onClose();
			}, timeout);
		}
	}]);

	return Message;
}();

exports.default = Message;
//# sourceMappingURL=Message.js.map