'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**

 <Dialog title="" onOk={} onCancel={} okButton={true} cancelButton={true} >

 **/
var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.state = {
      loading: false
    };

    _this.onCancel = function (e) {
      _this._onCancel(e);
      e.stopPropagation();
      return false;
    };

    _this.onOk = function (e) {
      _this._onOk(e);
    };

    _this.maskClick = function (e) {
      if (e.target.className.indexOf("modal-action") > -1) {
        _this._maskClick(e);
      }
    };

    _this.keyDown = function (e) {
      if (_this.props.display) {
        console.log(e);
        if (e.key === "Enter") {
          _this._onOk();
        } else if (e.key === "Escape") {
          _this._onCancel();
        }
      }
    };

    _this.setParams(props);
    return _this;
  }

  _createClass(Modal, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (this.props.enterClick) {
        document.addEventListener("keydown", this.keyDown);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.enterClick) {
        document.removeEventListener("keydown", this.keyDown);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      this.setParams(props);
    }
  }, {
    key: 'setParams',
    value: function setParams(props) {
      this.state.display = props.display;
      this.state.title = props.title;
      this.state.loading = props.loading;
      this.state.okButtonText = props.okButtonText;
      this.state.cancelButtonText = props.cancelButtonText;
      this.state.onOk = props.onOk;
      this.state.onCancel = props.onCancel;
    }
  }, {
    key: '_onOk',
    value: function _onOk() {
      //如果正在加载中，不允许重复点击
      if (this.state.loading) {
        return;
      }
      if (this.props.onOk) {
        this.props.onOk();
      }
    }
  }, {
    key: '_onCancel',
    value: function _onCancel() {
      if (this.props.onCancel) {
        this.props.onCancel();
      } else {
        this.setState({
          display: false
        });
      }
    }
  }, {
    key: '_maskClick',
    value: function _maskClick(e) {
      if (this.state.loading || !this.props.maskClick) {
        return;
      }

      this._onCancel(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          cancelButton = _props.cancelButton,
          onButton = _props.onButton,
          footer = _props.footer,
          style = _props.style,
          enterClick = _props.enterClick;
      var _state = this.state,
          okButtonText = _state.okButtonText,
          cancelButtonText = _state.cancelButtonText,
          title = _state.title,
          display = _state.display,
          loading = _state.loading,
          width = _state.width;

      var enterHover = { boxShadow: "0px 0px 0px 4px #C3DAFF" };
      if (footer === undefined) {
        footer = _react2.default.createElement(
          'div',
          { className: 'modal-footer' },
          cancelButton ? _react2.default.createElement(
            _Button2.default,
            { onClick: this.onCancel, disabled: loading, secondary: true },
            cancelButtonText
          ) : null,
          onButton ? _react2.default.createElement(
            _Button2.default,
            { style: enterClick ? enterHover : {}, onClick: this.onOk, disabled: loading,
              loading: loading },
            okButtonText
          ) : null
        );
      }

      if (style === undefined) {
        style = { marginBottom: 50 };
      } else {
        style.marginBottom = 50;
      }
      var content = _react2.default.createElement(
        'div',
        { className: 'modal-content ', style: style },
        _react2.default.createElement('span', { className: 'modal-close', onClick: this.onCancel }),
        _react2.default.createElement(
          'div',
          { className: 'modal-header' },
          title
        ),
        _react2.default.createElement(
          'div',
          { className: 'modal-body' },
          children
        ),
        footer
      );

      return _react2.default.createElement(
        'div',
        { className: display ? "modal modal-action" : "modal", onClick: this.maskClick },
        content
      );
    }
  }]);

  return Modal;
}(_react2.default.Component);

Modal.defaultProps = {
  cancelButton: true,
  onButton: true,
  loading: false,
  okButtonText: "确定",
  cancelButtonText: "取消",
  title: "提醒",
  display: false,
  maskClick: false,
  enterClick: false
};
Modal.propTypes = {
  display: _propTypes2.default.bool,
  onOk: _propTypes2.default.func,
  onCancel: _propTypes2.default.func,
  title: _propTypes2.default.string,
  loading: _propTypes2.default.bool,
  okButtonText: _propTypes2.default.string,
  onButton: _propTypes2.default.bool,
  cancelButtonText: _propTypes2.default.string,
  cancelButton: _propTypes2.default.bool,
  footer: _propTypes2.default.any,
  style: _propTypes2.default.object,
  maskClick: _propTypes2.default.bool,
  onHide: _propTypes2.default.func
};
exports.default = Modal;
//# sourceMappingURL=Modal.js.map