'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Pagination = function (_React$Component) {
  _inherits(Pagination, _React$Component);

  function Pagination(props) {
    _classCallCheck(this, Pagination);

    var _this = _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call(this, props));

    _this.defaultSize = 10;
    _this.state = {
      current: props.current || props.defaultCurrent || 1,
      countPage: Math.ceil((props.total || 0) / (props.pageSize || _this.defaultSize)),
      total: props.total || 0,
      maxShowPage: props.maxShowPage || 5,
      hideJumper: props.hideJumper !== undefined || false
    };
    return _this;
  }

  _createClass(Pagination, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      var countPage = Math.ceil((props.total || 0) / (props.pageSize || this.defaultSize));
      var data = {
        countPage: countPage,
        total: props.total || 0,
        maxShowPage: props.maxShowPage || 5
      };
      if (props.current) {
        data.current = props.current;
      }
      this.setState(data);
    }
  }, {
    key: 'toPageIndex',
    value: function toPageIndex(index) {
      index = parseInt(index);
      var _state = this.state,
          countPage = _state.countPage,
          current = _state.current;
      var pageSize = this.props.pageSize;

      if (1 <= index && index <= countPage) {
        this.setState({
          current: index
        });
        this.props.onChange(index, pageSize || this.defaultSize);
      } else {
        this.refs.goIndex.value = current;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state2 = this.state,
          current = _state2.current,
          countPage = _state2.countPage,
          total = _state2.total,
          maxShowPage = _state2.maxShowPage,
          hideJumper = _state2.hideJumper;

      var pages = [current];

      // 当前页分别向两侧增加两页
      for (var i = 1; i <= Math.floor(maxShowPage / 2); i++) {
        if (current - i >= 1) pages.unshift(current - i);
        if (current + i <= countPage) pages.push(current + i);
      }
      // 长度小于5,且第一页为1,最后一页小于总页数
      while (pages.length < 5 && pages[0] == 1 && pages[pages.length - 1] < countPage) {
        pages.push(pages[pages.length - 1] + 1);
      }

      // 长度小于5,且最后一页等于总页数,第一页大于1
      while (pages.length < 5 && pages[pages.length - 1] == countPage && pages[0] > 1) {
        pages.unshift(pages[0] - 1);
      }

      if (pages[0] > 3) {
        pages.unshift(".");
        pages.unshift(1);
      } else {
        while (pages[0] > 1) {
          pages.unshift(pages[0] - 1);
        }
      }

      if (pages[pages.length - 1] <= countPage - 3) {
        pages.push(".");
        pages.push(countPage);
      } else {
        while (pages[pages.length - 1] < countPage) {
          pages.push(pages[pages.length - 1] + 1);
        }
      }

      if (!hideJumper && countPage < 5) {
        hideJumper = true;
      }

      return _react2.default.createElement(
        'div',
        { className: 'pagination-wrapper con-wrapper', style: { marginBottom: 0, paddingBottom: "20px" } },
        _react2.default.createElement(
          'span',
          { className: 'pagination-total-text' },
          '\u5171 ',
          total,
          ' \u6761'
        ),
        _react2.default.createElement(
          'ul',
          { className: 'pagination' },
          _react2.default.createElement('li', { className: 'pagination-prev', onClick: this.toPageIndex.bind(this, current - 1) }),
          pages.map(function (page, i) {
            if (page == ".") {
              return _react2.default.createElement('li', { className: 'pagination-ellipsis', key: i });
            } else {
              return _react2.default.createElement(
                'li',
                { key: i, onClick: _this2.toPageIndex.bind(_this2, page),
                  className: page == current ? "pagination-item pagination-item-action" : "pagination-item" },
                _react2.default.createElement(
                  'a',
                  null,
                  page
                )
              );
            }
          }),
          _react2.default.createElement('li', { className: 'pagination-next', onClick: this.toPageIndex.bind(this, current + 1) })
        ),
        hideJumper ? null : _react2.default.createElement(
          'div',
          { className: 'pagination-options-quick-jumper' },
          '\u8DF3\u81F3 ',
          _react2.default.createElement('input', { type: 'text', name: '', className: 'input', ref: 'goIndex', onKeyPress: function onKeyPress(e) {
              if (e.key == "Enter") _this2.toPageIndex(e.target.value);
            } }),
          ' \u9875'
        )
      );
    }
  }]);

  return Pagination;
}(_react2.default.Component);

Pagination.propTypes = {
  onChange: _propTypes2.default.func.isRequired,
  total: _propTypes2.default.number.isRequired,
  current: _propTypes2.default.number,
  defaultCurrent: _propTypes2.default.number,
  pageSize: _propTypes2.default.number,
  maxShowPage: _propTypes2.default.number
};
exports.default = Pagination;
//# sourceMappingURL=Pagination.js.map