'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _server = require('react-dom/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popconfirm = function (_React$Component) {
  _inherits(Popconfirm, _React$Component);

  function Popconfirm(props) {
    _classCallCheck(this, Popconfirm);

    var _this = _possibleConstructorReturn(this, (Popconfirm.__proto__ || Object.getPrototypeOf(Popconfirm)).call(this, props));

    _this.wrapper = null;
    _this.popconfirm = null;

    _this.show = function () {
      _this.popconfirm.style.display = "block";
    };

    _this.hide = function () {
      _this.popconfirm.style.display = "none";
    };

    var inner = (0, _server.renderToString)(_this.props.content);
    return _this;
  }

  _createClass(Popconfirm, [{
    key: 'getElementLeft',
    value: function getElementLeft(element) {
      var actualLeft = element.offsetLeft;
      var current = element.offsetParent;
      while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;
      }
      return actualLeft;
    }
  }, {
    key: 'getElementTop',
    value: function getElementTop(element) {
      var actualTop = element.offsetTop;
      var current = element.offsetParent;
      while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
      }
      return actualTop;
    }
  }, {
    key: 'setPosition',
    value: function setPosition() {
      var wrapperStyle = getComputedStyle(this.wrapper, null);
      var popconfirmStyle = getComputedStyle(this.popconfirm, null);

      var wrapperWidth = parseFloat(wrapperStyle.width);
      var wrapperHeight = parseFloat(wrapperStyle.height);
      var popconfirmWidth = parseFloat(popconfirmStyle.width);
      var popconfirmHeight = parseFloat(popconfirmStyle.height);

      var wrapperTop = this.getElementTop(this.wrapper);
      var wrapperLeft = this.getElementLeft(this.wrapper);

      switch (this.props.direction) {
        case 'top':
          this.popconfirm.style.left = wrapperLeft + wrapperWidth / 2 + 'px';
          this.popconfirm.style.top = wrapperTop + 'px';
          break;
        case 'bottom':
          this.popconfirm.style.left = wrapperLeft + wrapperWidth / 2 + 'px';
          this.popconfirm.style.bottom = document.body.offsetHeight - wrapperTop - wrapperHeight + 'px';
          break;
        case 'left':
          this.popconfirm.style.left = wrapperLeft + 'px';
          this.popconfirm.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
        case 'right':
          this.popconfirm.style.left = 'auto';
          this.popconfirm.style.right = document.body.offsetWidth - wrapperLeft - wrapperWidth + 'px';
          this.popconfirm.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
        default:
          this.popconfirm.style.right = document.body.offsetWidth - wrapperLeft - wrapperWidth - 4 + 'px';
          this.popconfirm.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
      }
    }
  }, {
    key: 'createPopconfirm',
    value: function createPopconfirm() {
      var _props = this.props,
          direction = _props.direction,
          title = _props.title,
          content = _props.content,
          visible = _props.visible;

      var contentHTML = (0, _server.renderToString)(content); //将react对象转换为HTML字符串

      this.popconfirm = document.createElement('div');
      this.popconfirm.className = 'popover  popover-placement-' + direction + ' popover-action';
      this.popconfirm.style = '' + (visible ? 'display: block' : 'display: none');
      this.popconfirm.onclick = function (e) {
        e.stopPropagation();
      };

      this.popconfirm.innerHTML = '<div class=popover-content>\n      <div class=popover-arrow></div>\n      <div class="popover-inner">\n        ' + (title && '<div class="popover-title">' + title + '</div>') + '\n        <div class="popover-inner-content">\n          ' + contentHTML + '\n        </div>\n      </div>\n    </div>';
      document.body.appendChild(this.popconfirm);
      this.setPosition();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.createPopconfirm();
      document.body.addEventListener("click", function () {
        _this2.hide();
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'div',
        {
          ref: function ref(dom) {
            return _this3.wrapper = dom;
          },
          onClick: this.show,
          className: 'popover-wrapper'
        },
        this.props.children
      );
    }
  }]);

  return Popconfirm;
}(_react2.default.Component);

Popconfirm.defaultProps = {
  direction: "top",
  visible: false
};
Popconfirm.propTypes = {
  direction: _propTypes2.default.string,
  title: _propTypes2.default.string,
  content: _propTypes2.default.object,
  visible: _propTypes2.default.bool
};
exports.default = Popconfirm;
//# sourceMappingURL=Popconfirm.js.map