'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Radio = require('./Radio');

var _Radio2 = _interopRequireDefault(_Radio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioGroup = function (_React$Component) {
	_inherits(RadioGroup, _React$Component);

	function RadioGroup(props) {
		_classCallCheck(this, RadioGroup);

		var _this = _possibleConstructorReturn(this, (RadioGroup.__proto__ || Object.getPrototypeOf(RadioGroup)).call(this, props));

		_this.value = props.defaultValue;
		_this.name = props.name || "R_" + Math.floor(Math.random() * 10000000).toString(36);
		return _this;
	}

	_createClass(RadioGroup, [{
		key: 'componentDidMount',
		value: function componentDidMount() {}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			if (props.value) {
				this.value = props.value;
				this.onChange('', props.value);
			}
		}
	}, {
		key: 'onChange',
		value: function onChange(key, value) {
			var children = this.props.children;

			for (var i = 0; i < children.length; i++) {
				if (key) {
					if (key != 'radios' + i) {
						this.refs['radios' + i].checked = false;
					}
				} else if (value) {
					if (children[i].props.value != value) {
						this.refs['radios' + i].checked = false;
					} else if (children[i].props.value == value) {
						this.refs['radios' + i].checked = true;
					}
				}
			}
			if (key) {
				this.value = this.refs[key].value;
			}
			this.props.onChange && this.props.onChange(this.value);
		}
	}, {
		key: 'getRadios',
		value: function getRadios() {
			var _this2 = this;

			var _props = this.props,
			    children = _props.children,
			    defaultValue = _props.defaultValue;

			var Radios = children.map(function (v, k) {
				var _v$props = v.props,
				    value = _v$props.value,
				    children = _v$props.children;

				return _react2.default.createElement(
					_Radio2.default,
					_extends({ key: k, ref: 'radios' + k }, v.props, { defaultChecked: value == defaultValue ? true : false, name: _this2.name, onChange: function onChange() {
							_this2.onChange('radios' + k);
							v.props.onChange && v.props.onChange();
						} }),
					children
				);
			}) || [];
			return Radios;
		}
	}, {
		key: 'render',
		value: function render() {

			return _react2.default.createElement(
				'div',
				null,
				this.getRadios()
			);
		}
	}]);

	return RadioGroup;
}(_react2.default.Component);

RadioGroup.propTypes = {
	disabled: _propTypes2.default.bool,
	defaultChecked: _propTypes2.default.bool,
	defaultValue: _propTypes2.default.any,
	onChange: _propTypes2.default.func
};
exports.default = RadioGroup;
//# sourceMappingURL=RadioGroup.js.map