'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchInput = function (_React$Component) {
  _inherits(SearchInput, _React$Component);

  function SearchInput(props) {
    _classCallCheck(this, SearchInput);

    var _this = _possibleConstructorReturn(this, (SearchInput.__proto__ || Object.getPrototypeOf(SearchInput)).call(this, props));

    _this.value = _this.props.defaultValue != undefined ? _this.props.defaultValue : "";

    _this.state = {
      value: _this.value,
      action: false
    };

    _this.onChange = function (e) {
      _this.value = e.target.value;
      _this.props.onChange(_this.value);
    };
    return _this;
  }

  _createClass(SearchInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== undefined && nextProps.value != this.value) {
        this.value = nextProps.value;
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'onSelectItem',
    value: function onSelectItem(item) {

      // let preValue = this.value;
      this.value = item.text || item;
      this.setState({ value: this.value });
      this.onUnAction();

      // if (this.value !== preValue) {
      //   this.props.onChange && this.props.onChange(this.value);
      // }
      this.props.onChange && this.props.onChange(this.value);
      this.props.onSelect && this.props.onSelect(item);
    }
  }, {
    key: 'onUnAction',
    value: function onUnAction() {
      this.setState({
        action: false
      });
    }
  }, {
    key: 'onAction',
    value: function onAction(e) {
      if (e.target.tagName.toUpperCase() === "LI") {
        this.setState({
          action: false
        });
      } else {
        this.setState({
          action: true
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          dataSource = _props.dataSource,
          style = _props.style,
          placeholder = _props.placeholder;
      var action = this.state.action;


      var className = action ? "select action" : "select";

      return _react2.default.createElement(
        'div',
        { className: className, onMouseLeave: this.onUnAction.bind(this), onClick: this.onAction.bind(this),
          style: _extends({}, style) },
        _react2.default.createElement('input', { ref: 'input', style: { border: 0, width: "100%" }, placeholder: placeholder, onFocus: this.onChange,
          onChange: this.onChange, value: this.value }),
        dataSource && dataSource.length > 0 ? _react2.default.createElement(
          'div',
          { style: { paddingTop: 10, position: "absolute", marginLeft: -1, width: "100%", left: 0 } },
          _react2.default.createElement(
            'div',
            { className: 'select-dropdown', style: { marginTop: 0 } },
            _react2.default.createElement(
              'ul',
              null,
              dataSource.map(function (item, index) {
                return _react2.default.createElement(
                  'li',
                  { onClick: _this2.onSelectItem.bind(_this2, item), key: index },
                  item.text || item
                );
              })
            )
          )
        ) : null
      );
    }
  }]);

  return SearchInput;
}(_react2.default.Component);

SearchInput.propTypes = {
  dataSource: _propTypes2.default.array,
  placeholder: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,
  value: _propTypes2.default.any,
  onChange: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  style: _propTypes2.default.object
};
exports.default = SearchInput;
//# sourceMappingURL=SearchInput.js.map