'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.searchChange = function (e) {
      var dataSourceSearch = _this.props.dataSource;
      if (dataSourceSearch) {
        _this.setState({
          isSearch: true,
          searchValue: e.target.value,
          dataSource: dataSourceSearch.filter(function (item) {
            return item.text.indexOf(e.target.value) > -1;
          })
        });
      } else {
        _this.setState({
          isSearch: false,
          searchValue: '',
          dataSource: _this.props.dataSourceSearch
        });
      }
    };

    _this.value = _this.props.value != undefined ? _this.props.value : _this.props.defaultValue;

    _this.state = {
      defaultValue: _this.props.defaultValue,
      value: _this.value,
      action: false,
      dataSource: _this.props.dataSource || [],
      isSearch: false,
      searchValue: ''
    };
    return _this;
  }

  _createClass(Select, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== undefined && nextProps.value != this.state.value) {
        this.value = nextProps.value;
        this.setState({ value: nextProps.value });
      }
    }
  }, {
    key: 'onSelectItem',
    value: function onSelectItem(item) {

      var preValue = this.value;
      this.value = item.value;
      this.setState({ value: item.value, isSearch: false });
      this.onUnAction();

      if (item.value !== preValue) {
        this.props.onChange && this.props.onChange(item.value, item);
      }
    }
  }, {
    key: 'onUnAction',
    value: function onUnAction() {
      this.setState({
        isSearch: false,
        action: false,
        searchValue: '',
        dataSource: this.props.dataSource
      });
    }
  }, {
    key: 'onAction',
    value: function onAction(e) {
      this.setState({
        action: !this.state.action
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          disabled = _props.disabled,
          placeholder = _props.placeholder,
          defaultValue = _props.defaultValue,
          style = _props.style,
          showSearch = _props.showSearch;
      var _state = this.state,
          action = _state.action,
          value = _state.value,
          _state$dataSource = _state.dataSource,
          dataSource = _state$dataSource === undefined ? [] : _state$dataSource,
          isSearch = _state.isSearch,
          searchValue = _state.searchValue;

      var selectItem = dataSource.filter(function (item) {
        return item.value == value;
      });
      var showText = selectItem && selectItem[0] ? selectItem[0].text : placeholder;

      disabled = !disabled ? dataSource.length == 0 && !isSearch ? true : disabled : disabled;

      var className = disabled ? "select select-disabled" : action ? "select action" : "select";
      return _react2.default.createElement(
        'div',
        { className: className, onMouseLeave: this.onUnAction.bind(this), onClick: this.onAction.bind(this), style: _extends({}, style) },
        _react2.default.createElement(
          'div',
          { className: 'select-inner', style: { opacity: isSearch ? '0' : '1' } },
          showText
        ),
        _react2.default.createElement('span', { className: 'icon-select' }),
        showSearch && !disabled ? _react2.default.createElement(
          'div',
          { style: { position: "absolute", top: 0, left: 0, right: 0, padding: 8 } },
          _react2.default.createElement('input', { value: searchValue, onChange: this.searchChange, style: { width: "100%", height: "100%", fontSize: "14px", color: "#666", border: "none", background: "transparent" } })
        ) : '',
        _react2.default.createElement(
          'div',
          { style: { paddingTop: 10, position: "absolute", marginLeft: -1, width: "100%", left: 0 } },
          _react2.default.createElement(
            'div',
            { className: 'select-dropdown', style: { marginTop: 0 } },
            _react2.default.createElement(
              'ul',
              null,
              dataSource.map(function (item, index) {
                return _react2.default.createElement(
                  'li',
                  { onClick: _this2.onSelectItem.bind(_this2, item), className: item.value == value ? "item-action" : "", key: index },
                  item.text
                );
              })
            )
          )
        )
      );
    }
  }]);

  return Select;
}(_react2.default.Component);

Select.propTypes = {
  dataSource: _propTypes2.default.array.isRequired,
  placeholder: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,
  value: _propTypes2.default.any,
  disabled: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  style: _propTypes2.default.object,
  showSearch: _propTypes2.default.bool
};
exports.default = Select;
//# sourceMappingURL=Select.js.map