'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Switch = function (_React$Component) {
	_inherits(Switch, _React$Component);

	function Switch(props) {
		_classCallCheck(this, Switch);

		var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

		_this.state = { checked: props.defaultChecked || props.checked || false };
		_this.checked = props.defaultChecked || props.checked || false;
		return _this;
	}

	_createClass(Switch, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			if (props.checked !== undefined) {
				this.setState({
					checked: props.checked
				});
				this.checked = props.checked;
				this.refs['input'].checked = props.checked;
			}
		}
	}, {
		key: 'onChange',
		value: function onChange(e) {
			var checked = this.state.checked;

			if (this.props.disabled) {
				return;
			}
			this.refs['input'].checked = !checked;
			this.setState({
				checked: !checked
			});
			this.props.onChange && this.props.onChange(!checked);
		}
	}, {
		key: 'render',
		value: function render() {
			var disabled = this.props.disabled;
			var checked = this.state.checked;

			return _react2.default.createElement(
				'span',
				{ className: "checkbox-switch " + (checked ? "switch-on " : "switch-off ") + (disabled ? "switch-disabled" : null), onClick: this.onChange.bind(this) },
				_react2.default.createElement(
					'span',
					{ className: 'switch' },
					' '
				),
				_react2.default.createElement('input', _extends({ className: 'input', ref: 'input', type: 'checkbox' }, this.props))
			);
		}
	}]);

	return Switch;
}(_react2.default.Component);

Switch.propTypes = {
	disabled: _propTypes2.default.bool,
	defaultChecked: _propTypes2.default.bool,
	checked: _propTypes2.default.bool,
	defaultValue: _propTypes2.default.string,
	onChange: _propTypes2.default.func
};
exports.default = Switch;
//# sourceMappingURL=Switch.js.map