'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.state = {
      selectAll: false,
      rowSelection: props.rowSelection
    };
    return _this;
  }

  _createClass(Table, [{
    key: 'renderTD',
    value: function renderTD(item, columnsKeys, columnMaps, trIndex) {
      return columnsKeys.map(function (key, index) {
        return _react2.default.createElement(
          'td',
          { key: index },
          columnMaps[key] && columnMaps[key].render ? columnMaps[key].render(item[key], item, trIndex) : item[key]
        );
      });
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick(rowData, index) {
      var rowSelection = this.state.rowSelection;

      if (rowSelection) {
        //如果列表需要选择，则选中或者取消选中
        rowSelection = Object.assign({}, rowSelection);
        var key = rowData.key;
        rowSelection.selectedRowKeys = rowSelection.selectedRowKeys || [];
        var inIndex = rowSelection.selectedRowKeys.indexOf(key);
        if (inIndex === -1) {
          //未有
          rowSelection.selectedRowKeys.push(key);
        } else {
          rowSelection.selectedRowKeys.splice(inIndex, 1);
        }

        this.setState({
          selectAll: rowSelection.selectedRowKeys.length == this.getDataSource().length,
          rowSelection: rowSelection
        });
        this.onSelectRowChange(rowSelection);
      }

      this.props.onRowClick && this.props.onRowClick(rowData, index);
    }
  }, {
    key: 'onSelectRowChange',
    value: function onSelectRowChange(rowSelection) {
      var dataSource = this.props.dataSource;

      var rows = dataSource.filter(function (item) {
        return rowSelection.selectedRowKeys.indexOf(item.key) != -1;
      });
      this.props.rowSelection && this.props.rowSelection.onChange && this.props.rowSelection.onChange(rowSelection.selectedRowKeys, rows);
    }
  }, {
    key: 'reset',
    value: function reset() {
      var rowSelection = this.state.rowSelection;

      rowSelection.selectedRowKeys = [];
      this.setState({
        selectAll: false,
        rowSelection: rowSelection
      });
      this.onSelectRowChange(rowSelection);
    }

    //添加选择头

  }, {
    key: 'addSelectionCloumns',
    value: function addSelectionCloumns(columns) {
      var rowSelection = this.state.rowSelection;

      var selectedRowKeys = rowSelection.selectedRowKeys || [];
      return [{
        title: "选择项",
        key: "$_select",
        render: function render(text, item) {
          return _react2.default.createElement('input', { type: 'checkbox', checked: selectedRowKeys.indexOf(item.key) != -1, onChange: function onChange() {} });
        }
      }].concat(columns);
    }
  }, {
    key: 'getDataSource',
    value: function getDataSource() {
      //限制最大显示行数
      var _props = this.props,
          pageSize = _props.pageSize,
          dataSource = _props.dataSource;


      if (pageSize) {
        dataSource = dataSource.slice(0, pageSize);
      }

      return dataSource;
    }
    //渲染自己定义的头 比如全选按钮

  }, {
    key: 'renderTh',
    value: function renderTh(item) {
      var _this2 = this;

      if (item.key === "$_select") {
        //如果当前列表需要选中行选中，渲染一个全选checkbox
        var _state = this.state,
            selectAll = _state.selectAll,
            rowSelection = _state.rowSelection;
        var _props2 = this.props,
            dataSource = _props2.dataSource,
            pageSize = _props2.pageSize;

        return _react2.default.createElement('input', {
          type: 'checkbox',
          checked: selectAll,
          onChange: function onChange() {
            //全选
            rowSelection.selectedRowKeys = selectAll ? [] : dataSource.slice(0, pageSize).map(function (item) {
              return item.key;
            });
            _this2.setState({
              selectAll: !selectAll,
              rowSelection: rowSelection
            });
            _this2.onSelectRowChange(rowSelection);
          }
        });
      }

      return item.title;
    }
  }, {
    key: 'renderNoData',
    value: function renderNoData(dataSource, columns) {
      var loading = this.props.loading;

      var context = null;

      if (dataSource.length) {
        return null;
      }

      if (dataSource.length == 0 && loading) {
        context = _react2.default.createElement(
          'div',
          { className: 'loading-wrapper' },
          _react2.default.createElement('span', { className: 'loading' }),
          _react2.default.createElement(
            'span',
            null,
            '\u6B63\u5728\u52A0\u8F7D\u4E2D...'
          )
        );
      } else {
        context = "暂无数据";
      }

      return _react2.default.createElement(
        'tr',
        null,
        _react2.default.createElement(
          'td',
          { colSpan: columns.length + 1, style: { textAlign: "center" } },
          context
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props3 = this.props,
          dataSource = _props3.dataSource,
          columns = _props3.columns,
          isIndex = _props3.isIndex,
          pageSize = _props3.pageSize,
          rowSelection = _props3.rowSelection,
          rowKey = _props3.rowKey;

      //如果要显示行号

      if (isIndex) {
        columns = [{ title: "#", key: "_index" }].concat(columns);
        dataSource = dataSource.map(function (item, index) {
          item._index = index + 1;return item;
        });
      }

      //列表可选择
      if (rowSelection) {
        columns = this.addSelectionCloumns(columns);
      }

      dataSource = this.getDataSource();

      var columnMaps = {};
      var columnsKeys = columns.map(function (item) {
        columnMaps[item.key] = item;
        return item.key;
      });

      return _react2.default.createElement(
        'table',
        { className: 'table' },
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            null,
            columns.map(function (item, index) {
              return _react2.default.createElement(
                'th',
                { key: index },
                _this3.renderTh(item)
              );
            })
          )
        ),
        _react2.default.createElement(
          'tbody',
          null,
          dataSource.map(function (item, index) {
            return _react2.default.createElement(
              'tr',
              {
                key: item[rowKey] || item.key || index,
                className: rowSelection && rowSelection.selectedRowKeys.indexOf(item.key) != -1 ? "active" : "",
                onClick: _this3.onRowClick.bind(_this3, item, index)
              },
              _this3.renderTD(item, columnsKeys, columnMaps, index)
            );
          }),
          this.renderNoData(dataSource, columns)
        )
      );
    }
  }]);

  return Table;
}(_react2.default.Component);

Table.propTypes = {
  dataSource: _propTypes2.default.array.isRequired,
  columns: _propTypes2.default.array.isRequired,
  onRowClick: _propTypes2.default.func, //行点击
  isIndex: _propTypes2.default.bool, //显示行号
  loading: _propTypes2.default.bool, //是否记载中
  pageSize: _propTypes2.default.number, //最大显示的行数
  rowKey: _propTypes2.default.string,
  /**
    {
      type:"checkbox|radio" //单选多选，默认多选
      selectedRowKeys:"" //默认选中的项目
      onChange:(selectedRowKeys, selectedRows)=>{}
    }
  **/
  rowSelection: _propTypes2.default.any //配置列表项可选
};
exports.default = Table;
//# sourceMappingURL=Table.js.map