'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$Component) {
	_inherits(Input, _React$Component);

	function Input(props) {
		_classCallCheck(this, Input);

		var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

		_this.value = props.defaultValue || "";
		var times = _this.value.split(":");
		_this.state = {
			action: false,
			select: {
				hour: times[0] || "",
				minute: times[1] || ""
			},
			value: _this.value
		};
		_this.length = {
			hour: 24,
			minute: 60
		};
		return _this;
	}

	_createClass(Input, [{
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(props) {
			if (props.value !== undefined && props.value != this.value) {
				this.value = props.value;
				var times = this.value.split(":");
				this.setState({
					select: {
						hour: times[0] || "",
						minute: times[1] || ""
					},
					value: this.value
				});
			}
		}
	}, {
		key: 'getTime',
		value: function getTime(type) {
			var _this2 = this;

			var select = this.state.select;

			var time = [];

			var _loop = function _loop(_i) {
				_i = _i < 10 ? '0' + _i : _i;
				time.push(_react2.default.createElement(
					'li',
					{ key: _i, value: _i, className: select[type] == _i ? "item-action" : "", onMouseDown: function onMouseDown(e) {
							!(_this2.props.autoClose && type == 'minute') && e.preventDefault();
							_this2.onSelect(type, _i);
						} },
					_i
				));
				i = _i;
			};

			for (var i = 0; i < this.length[type]; i++) {
				_loop(i);
			}
			return _react2.default.createElement(
				'div',
				{ className: 'time-picker-select' },
				_react2.default.createElement(
					'ul',
					null,
					time
				)
			);
		}
	}, {
		key: 'onSelect',
		value: function onSelect(type, item) {
			var select = this.state.select;

			select[type] = item;
			this.value = (select['hour'] || '00') + ":" + (select['minute'] || "00");
			this.setState({
				select: select,
				value: this.value
			});
		}
	}, {
		key: 'onFocus',
		value: function onFocus() {
			this.setState({
				action: true
			});
		}
	}, {
		key: 'onBlur',
		value: function onBlur() {
			this.setState({
				action: false
			});
			this.onChange();
		}
	}, {
		key: 'onChange',
		value: function onChange() {
			this.props.onChange && this.props.onChange(this.value);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _state = this.state,
			    action = _state.action,
			    value = _state.value;
			var _props = this.props,
			    disabled = _props.disabled,
			    placeholder = _props.placeholder;

			return _react2.default.createElement(
				'div',
				{ className: "time-picker " + (action ? "time-picker-action " : "") + (disabled ? "time-picker-disabled" : "") },
				_react2.default.createElement(
					'div',
					{ className: 'time-picker-input-wrapper ' },
					_react2.default.createElement('input', { type: '', name: '', className: 'time-picker-input', ref: 'input', disabled: disabled, value: value, onChange: function onChange(e) {
							_this3.onChange();
						}, placeholder: placeholder,
						onFocus: this.onFocus.bind(this),
						onBlur: this.onBlur.bind(this)
					}),
					_react2.default.createElement('span', { className: 'icon-time-picker' })
				),
				_react2.default.createElement(
					'div',
					{ className: 'time-picker-combobox-wrapper' },
					this.getTime('hour'),
					this.getTime('minute')
				)
			);
		}
	}]);

	return Input;
}(_react2.default.Component);

Input.propTypes = {
	type: _propTypes2.default.string,
	disabled: _propTypes2.default.bool,
	defaultValue: _propTypes2.default.string,
	onChange: _propTypes2.default.func,
	// width:PropTypes.string,
	// height:PropTypes.string,
	placeholder: _propTypes2.default.string,
	autoClose: _propTypes2.default.bool
};
exports.default = Input;
//# sourceMappingURL=TimerPicker.js.map