'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var directionSet = {
  top: true,
  bottom: true,
  left: true,
  right: true
};

var Tooltip = function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  function Tooltip() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call.apply(_ref, [this].concat(args))), _this), _this.tooltip = null, _this.wrapper = null, _this.mouseEnter = function () {
      _this.createToolTip();
      _this.props.onEnter && _this.props.onEnter();
    }, _this.mouseLeave = function () {
      _this.removeToolTip();
      _this.props.onLeave && _this.props.onLeave();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tooltip, [{
    key: 'getDirection',
    value: function getDirection() {
      var direction = this.props.direction;

      return directionSet[direction] ? direction : 'right';
    }
  }, {
    key: 'getElementLeft',
    value: function getElementLeft(element) {
      var actualLeft = element.offsetLeft;
      var current = element.offsetParent;
      while (current !== null) {
        actualLeft += current.offsetLeft;
        current = current.offsetParent;
      }
      return actualLeft;
    }
  }, {
    key: 'getElementTop',
    value: function getElementTop(element) {
      var actualTop = element.offsetTop;
      var current = element.offsetParent;
      while (current !== null) {
        actualTop += current.offsetTop;
        current = current.offsetParent;
      }
      return actualTop;
    }
  }, {
    key: 'setPosition',
    value: function setPosition() {
      var wrapperStyle = getComputedStyle(this.wrapper, null);
      var tooltipStyle = getComputedStyle(this.tooltip, null);

      var wrapperWidth = parseFloat(wrapperStyle.width);
      var wrapperHeight = parseFloat(wrapperStyle.height);
      var tooltipWidth = parseFloat(tooltipStyle.width);
      var tooltipHeight = parseFloat(tooltipStyle.height);

      var wrapperTop = this.getElementTop(this.wrapper);
      var wrapperLeft = this.getElementLeft(this.wrapper);

      switch (this.props.direction) {
        case 'top':
          this.tooltip.style.left = wrapperLeft + wrapperWidth / 2 + 'px';
          this.tooltip.style.top = wrapperTop + 'px';
          break;
        case 'bottom':
          this.tooltip.style.left = wrapperLeft + wrapperWidth / 2 + 'px';
          this.tooltip.style.bottom = document.body.offsetHeight - wrapperTop - wrapperHeight + 'px';
          break;
        case 'left':
          this.tooltip.style.left = wrapperLeft + 'px';
          this.tooltip.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
        case 'right':
          this.tooltip.style.right = document.body.offsetWidth - wrapperLeft - wrapperWidth - 4 + 'px';
          this.tooltip.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
        default:
          this.tooltip.style.right = document.body.offsetWidth - wrapperLeft - wrapperWidth - 4 + 'px';
          this.tooltip.style.top = wrapperTop + wrapperHeight / 2 + 'px';
          break;
      }
    }

    //在body元素的末尾创建tooltip悬浮框

  }, {
    key: 'createToolTip',
    value: function createToolTip() {
      this.tooltip = document.createElement('div');
      this.tooltip.className = 'tooltip tooltip-action tooltip-placement-' + this.getDirection();
      this.tooltip.innerHTML = '<div class="tooltip-arrow"></div>\n<div class="tooltip-inner" style="white-space: normal; word-break:normal;">' + this.props.title + '</div>';
      document.body.appendChild(this.tooltip);
      this.setPosition();
    }

    //移除之前创建的tooltip悬浮框

  }, {
    key: 'removeToolTip',
    value: function removeToolTip() {
      this.tooltip && document.body.removeChild(this.tooltip);
      this.tooltip = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;


      return _react2.default.createElement(
        'div',
        {
          ref: function ref(dom) {
            return _this2.wrapper = dom;
          },
          className: 'tooltip-wrapper',
          onMouseEnter: this.mouseEnter,
          onMouseLeave: this.mouseLeave },
        children
      );
    }
  }]);

  return Tooltip;
}(_react2.default.Component);

Tooltip.defaultProps = {
  direction: 'right'
};
Tooltip.propTypes = {
  title: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.element.isRequired,
  direction: _propTypes2.default.string,
  onEnter: _propTypes2.default.func,
  onLeave: _propTypes2.default.func
};
exports.default = Tooltip;
//# sourceMappingURL=Tooltip.js.map