'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Message = require('./Message');

var _Message2 = _interopRequireDefault(_Message);

var _Progress = require('./Progress');

var _Progress2 = _interopRequireDefault(_Progress);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import {Button} from './index'


var Upload = function (_Component) {
  _inherits(Upload, _Component);

  function Upload(props) {
    _classCallCheck(this, Upload);

    var _this = _possibleConstructorReturn(this, (Upload.__proto__ || Object.getPrototypeOf(Upload)).call(this, props));

    _this.state = { process: 0 };
    _this.elementId = props.id || "fileInput_" + Math.floor(Math.random() * 100000000000);

    _this.fileInputChange = function (e) {
      _this._fileInputChange(e);
    };

    _this.uploadClick = function (e) {
      _this._uploadClick(e);
    };
    return _this;
  }

  _createClass(Upload, [{
    key: 'reset',
    value: function reset() {
      document.getElementById(this.elementId).value = "";
    }
  }, {
    key: '_uploadClick',
    value: function _uploadClick() {
      document.getElementById(this.elementId).click();
    }
  }, {
    key: '_fileInputChange',
    value: function _fileInputChange(e) {
      var _props = this.props,
          customRequest = _props.customRequest,
          accept = _props.accept;

      var files = e.currentTarget.files || [];
      if (files.length === 0) {
        return false;
      }
      if (files[0].type.indexOf(accept) > -1) {
        if (customRequest && typeof customRequest === "function") {
          customRequest(e);
        } else {
          this.uploadFile(files);
        }
      } else {
        _Message2.default.error('\u8BF7\u9009\u62E9' + accept + '\u6587\u4EF6');
      }
      this.reset();
    }
  }, {
    key: 'tryToJSON',
    value: function tryToJSON(str) {
      if (typeof str === 'string') {
        try {
          return eval('evalJSONString(' + str + ')');
        } catch (e) {}

        try {
          return JSON.parse(str);
        } catch (e) {}

        return str;
      }
    }
  }, {
    key: 'uploadFile',
    value: function uploadFile(files) {
      var _this2 = this;

      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var _props2 = this.props,
          action = _props2.action,
          onLoad = _props2.onLoad,
          onProgress = _props2.onProgress,
          onError = _props2.onError,
          withCredentials = _props2.withCredentials,
          accept = _props2.accept,
          size = _props2.size;

      var self = this;

      var formData = new FormData();
      var file = files[index];
      if (size.maxSize && file.size > size.maxSize) {
        _Message2.default.error("文件超出大小限制");
      }
      formData.append("file", file);

      var xhr = new XMLHttpRequest();
      xhr.upload.onprogress = onProgress || function (e) {
        self.setState({ process: parseInt(e.loaded / e.total * 100) });
      };

      xhr.onload = function (e) {
        var current = e.currentTarget;
        self.setState({ upload: false });
        if (Math.floor(current.status / 100) === 2 || Math.floor(current.status / 100) === 3) {
          var res = _this2.tryToJSON(current.responseText);
          onLoad && onLoad(res, e);
        } else {
          onError && onError({ msg: "请求失败", resultCode: current.status }, e);
        }
      };

      xhr.onerror = onError || function (e) {
        console.error("onerror", e);
        self.setState({ process: 0, upload: true });
      };

      xhr.open("POST", action, true);
      xhr.withCredentials = withCredentials;

      if (accept === "image" && (size.width || size.height || action === "base64")) {
        var reader = new FileReader();
        reader.onload = function (e) {
          var data = e.target.result;
          //加载图片获取图片真实宽度和高度
          var image = new Image();
          image.onload = function () {
            var width = image.width;
            var height = image.height;
            if (size.width && size.width != width) {
              _Message2.default.error("图片宽度不符合要求");
              return false;
            }
            if (size.height && size.height != height) {
              _Message2.default.error("图片高度不符合要求");
              return false;
            }
            if (action === "base64") {
              self.value = data;
              onLoad && onLoad(data, e);
            } else {
              xhr.send(formData);
              self.setState({ process: 0, upload: true });
            }
          };
          image.src = data;
        };
        reader.readAsDataURL(file);
      } else {
        xhr.send(formData);
        self.setState({ process: 0, upload: true });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          desc = _props3.desc,
          disabled = _props3.disabled,
          children = _props3.children,
          fileList = _props3.fileList,
          removeFile = _props3.removeFile,
          listType = _props3.listType,
          showProgress = _props3.showProgress;

      fileList = fileList || [];

      var _state = this.state,
          upload = _state.upload,
          process = _state.process;


      if (!children) children = "上传文件";

      return _react2.default.createElement(
        'div',
        { className: 'upload-wrapper upload-file' },
        _react2.default.createElement(
          'div',
          { className: 'upload' },
          _react2.default.createElement('input', { type: 'file', className: 'file-input', id: this.elementId, onChange: this.fileInputChange }),
          _react2.default.createElement(
            _Button2.default,
            { disabled: disabled, onClick: this.uploadClick, secondary: true },
            _react2.default.createElement('span', { className: 'icon-antion-hover-upload' }),
            '\xA0',
            children
          )
        ),
        desc ? _react2.default.createElement(
          'div',
          { className: 'explain' },
          desc
        ) : null,
        upload && showProgress ? _react2.default.createElement(_Progress2.default, { progress: process, type: process == 100 ? "success" : "" }) : null,
        listType === 'text' && fileList.length > 0 ? _react2.default.createElement(
          'div',
          { className: 'd-list' },
          fileList.map(function (file, i) {
            var fileName = file;
            var href = "";
            if ((typeof file === 'undefined' ? 'undefined' : _typeof(file)) === "object") {
              fileName = file.name;
              href = file.href || "";
            }
            return _react2.default.createElement(
              'div',
              { className: 'upload-list-item', key: i },
              _react2.default.createElement('span', { className: 'icon-antion-clip' }),
              href ? _react2.default.createElement(
                'a',
                { className: 'txt-link', style: { paddingRight: "40px" }, href: href,
                  target: '_blank' },
                fileName
              ) : _react2.default.createElement(
                'a',
                { className: 'txt-link', style: { paddingRight: "40px" } },
                fileName
              ),
              removeFile && typeof removeFile === 'function' ? _react2.default.createElement('span', { className: 'icon-antion-hover-remove', onClick: function onClick() {
                  removeFile(file);
                } }) : null
            );
          })
        ) : null,
        listType === 'picture' && fileList.length > 0 ? _react2.default.createElement(
          'div',
          { style: { marginTop: 10 } },
          fileList.map(function (file, i) {
            var href = file;
            if ((typeof file === 'undefined' ? 'undefined' : _typeof(file)) === "object") {
              href = file.href || "";
            }
            return _react2.default.createElement(
              'div',
              { key: i, className: 'upload-wrapper upload-picture-card upload-picture-card-after' },
              _react2.default.createElement('img', { src: href }),
              _react2.default.createElement(
                'div',
                { className: 'upload-picture-icon' },
                _react2.default.createElement(
                  'a',
                  { className: 'upload-picture-item-thumbnail', href: href, target: '_blank' },
                  _react2.default.createElement('span', { className: 'icon-antion-see' })
                ),
                _react2.default.createElement('span', { className: 'icon-antion-delete', onClick: function onClick() {
                    removeFile(file);
                  } })
              )
            );
          })
        ) : null
      );
    }
  }]);

  return Upload;
}(_react.Component);

Upload.defaultProps = {
  desc: "",
  accept: "",
  size: {},
  disabled: false,
  withCredentials: false,
  fileList: [],
  listType: 'text',
  showProgress: false
};
Upload.propTypes = {
  action: _propTypes2.default.string.isRequired,
  desc: _propTypes2.default.string,
  onLoad: _propTypes2.default.func,
  onProgress: _propTypes2.default.func,
  showProgress: _propTypes2.default.bool,
  onError: _propTypes2.default.func,
  accept: _propTypes2.default.string,
  customRequest: _propTypes2.default.func,
  disabled: _propTypes2.default.bool,
  withCredentials: _propTypes2.default.bool,
  fileList: _propTypes2.default.array,
  removeFile: _propTypes2.default.func,
  listType: _propTypes2.default.string
};
exports.default = Upload;
//# sourceMappingURL=Upload.js.map