'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default.Button,
      { size: 'lg' },
      '\u5927\u6309\u94AE lg  1232131221'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.Button,
      { size: 'sm' },
      '\u5C0F\u6309\u94AE sm'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.Button,
      { size: 'lg', loading: true },
      '\u52A0\u8F7D\u4E2D...'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.Button,
      { size: 'lg', disabled: true },
      '\u7981\u7528\u6309\u94AE'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.Button,
      { size: 'lg', secondary: true },
      '\u6B21\u7EA7\u6309\u94AE'
    )
  );
}

function params() {

  var dataSource = [{
    key: "size",
    type: "string",
    "default": "sm",
    mark: "可选值 lg, sm"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: "是否禁用按钮"
  }, {
    key: "loading",
    type: "bool",
    "default": "false",
    mark: "是否加载中"
  }, {
    key: "secondary",
    type: "bool",
    "default": "false",
    mark: "是否为次级按钮"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    import {Button} from \'react-piros\'\n    \n    <Button size="lg">\n      \u5927\u6309\u94AE lg  1232131221\n    </Button>\n\n    <Button size="sm">\n      \u5C0F\u6309\u94AE sm\n    </Button>\n\n    <Button size="lg" loading={true}>\n      \u52A0\u8F7D\u4E2D...\n    </Button>\n\n    <Button size="lg" disabled={true}>\n      \u7981\u7528\u6309\u94AE\n    </Button>\n\n    <Button size="lg"  secondary={true}>\n      \u6B21\u7EA7\u6309\u94AE\n    </Button>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Button.js.map