'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  var onChange = function onChange(checked) {
    console.log("checked:", checked);
    _this.setState({
      checked: checked
    });
  };

  var onChangeGroup = function onChangeGroup(checked) {
    console.log("checked:", checked);
    _this.setState({
      checkedList: checked
    });
  };
  var _state = this.state,
      checked = _state.checked,
      checkedList = _state.checkedList;

  if (checked === undefined) checked = true;
  if (checkedList === undefined) checkedList = ['2'];

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index2.default.CheckBox, { onChange: onChange, checked: checked, label: '\u9009\u62E9' }),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.CheckBoxGroup, { options: [{ label: "选择一", value: "1" }, { label: "选择二", value: "2" }, { label: "选择三", value: "3" }], onChange: onChangeGroup, checked: checkedList, disabled: ["2"] })
  );
}

function params() {

  var dataSource = [{
    key: "checked",
    type: "bool",
    "default": "false",
    mark: "总条数"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: ""
  }, {
    key: "label",
    type: "String",
    "default": "",
    mark: "label"
  }, {
    key: "onChange",
    type: "function",
    "default": "",
    mark: "选择变化回调，返回选中值"
  }];

  var groupDataSource = [{
    key: "checked",
    type: "array",
    "default": "[]",
    mark: "选择值的列表"
  }, {
    key: "disabled",
    type: "array",
    "default": "[]",
    mark: "disable选择框的列表"
  }, {
    key: "options",
    type: "array",
    "default": "",
    mark: '\u9009\u62E9\u6846\u5217\u8868\uFF1A[{label:"\u9009\u62E9\u4E00",value:"1"},{label:"\u9009\u62E9\u4E8C",value:"2"}]'
  }, {
    key: "onChange",
    type: "function",
    "default": "",
    mark: "选择变化回调，返回选中值列表"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns }),
    ';',
    _react2.default.createElement(_index2.default.Table, { dataSource: groupDataSource, columns: columns }),
    ';'
  );
}

function code() {
  return '\n   let onChange =(checked) => {\n    console.log("checked:",checked)\n    this.setState({\n      checked:checked\n    })\n  }\n\n  let onChangeGroup =(checked) => {\n    console.log("checked:",checked)\n    this.setState({\n      checkedList:checked\n    })\n  }\n  let {checked, checkedList} = this.state;\n  if (checked === undefined) checked = true;\n  if (checkedList === undefined) checkedList = [\'1\'];\n\n  return <div>\n      <PIROS.CheckBox onChange={onChange} checked={checked} label="\u9009\u62E9"/>\n    <br/>\n    <br/>\n    <PIROS.CheckBoxGroup options={[{label:"\u9009\u62E9\u4E00",value:"1"},{label:"\u9009\u62E9\u4E8C",value:"2"}]} onChange={onChangeGroup} checked={checkedList}/>\n    </div>\n    ';
}

module.exports = {
  title: "CheckBox 多选框",
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=CheckBox.js.map