'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  return _react2.default.createElement(
    'div',
    null,
    '\u6574\u4F53\u5E03\u5C40'
  );
}

function params() {
  var dataSource = [{
    key: "title",
    type: "string",
    "default": "PIROS",
    mark: "标题"
  }, {
    key: "isShowSide",
    type: "bool",
    "default": "true",
    mark: "是否显示侧边栏"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n      import {Layout,Menu} from \'react-piros\'\n      let {Side,Context} = Layout;\n\n\n      let menus = {\n        title:"General",\n        key:"General",\n        list:[\n          {\n            title:"Index",\n            component:IndexDOC,\n            href:"/Index"\n          }\n        ]\n      };\n\n      <Layout title="title" >\n        <Side>\n          <Menu \n            dataSource={menus}\n            selectedKeys={["General"]}\n          />\n        </Side>\n        <Context>\n          Hello world\n        </Context>\n      </Layout>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Layout.js.map