'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index.Menu, {
      dataSource: [{
        title: "栏目1",
        key: "m1",
        list: [{
          title: "sub1",
          key: "sub1"
        }]
      }, {
        title: "栏目2",
        key: "m2",
        list: [{
          title: "sub2",
          key: "sub2"
        }]
      }],
      openKeys: ["m2"],
      defaultOpenKeys: ["m1"],
      defaultSelectedKeys: ["sub2"],
      onSelect: function onSelect(menu) {
        console.log(menu);
      }
    })
  );
}

function params() {

  var dataSource = [{
    key: "dataSource",
    type: "Array",
    defaultValue: "[ItemSource,ItemSource]",
    mark: "数组"
  }, {
    key: "defaultOpenKeys",
    type: "Array",
    defaultValue: "[]",
    mark: "默认打开的菜单key"
  }, {
    key: "defaultSelectedKeys",
    type: "Array",
    defaultValue: "[]",
    mark: "默认选中的菜单key, 目前只支持单选，未来可能支持多选"
  }, {
    key: "onSelect",
    type: "func",
    defaultValue: "(key, item, event)=>{}",
    mark: "菜单被选中的时候出发"
  }];
  var dataSource2 = [{
    key: "title",
    type: "String",
    defaultValue: "",
    mark: "[可选]显示名"
  }, {
    key: "href",
    type: "String",
    defaultValue: "",
    mark: "[可选]链接地址"
  }, {
    key: "key",
    type: "String",
    defaultValue: "",
    mark: "[必选]key值必须"
  }, {
    key: "list",
    type: "Array",
    defaultValue: "[ItemSource,ItemSource]",
    mark: "[可选]二级菜单"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "defaultValue"
  }, {
    title: "说明",
    key: "mark"
  }];
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h3',
      null,
      'dataSource'
    ),
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns }),
    _react2.default.createElement(
      'h3',
      null,
      'ItemSource'
    ),
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource2, columns: columns })
  );
}

function code() {
  return '\n      <Menu\n        dataSource={\n          [\n             {\n                title:"\u680F\u76EE1",\n                key:"m1",\n                list:[\n                  { \n                    title:"sub1",\n                    key:"sub1"\n                  }\n                ]\n             },\n             {\n                title:"\u680F\u76EE2",\n                key:"m2",\n                list:[\n                  { \n                    title:"sub2",\n                    key:"sub2"\n                  }\n                ]\n             } \n          ]\n        }\n        openKeys={["m2"]}\n        defaultOpenKeys ={["m1"]}\n        defaultSelectedKeys ={["sub2"]}\n        onSelect = {(menu)=>{\n          console.log(menu)\n        }}\n      />\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Menu.js.map