'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
	var info = function info() {
		_index2.default.message.info("This is a message of info");
	};
	var success = function success() {
		_index2.default.message.success('This is a message of success');
	};

	var error = function error() {
		_index2.default.message.error('This is a message of error,set timeout =1000ms', 1000, 'ww');
	};

	var warning = function warning() {
		_index2.default.message.warning('This is message of warning', 1000, function () {
			console.log('回调函数onClose');
		});
	};

	var loading = function loading() {
		_index2.default.message.loading('This is message of warning');
	};

	return _react2.default.createElement(
		'div',
		null,
		_react2.default.createElement(
			_index2.default.Button,
			{ size: 'sm', onClick: info },
			'\u666E\u901A\u63D0\u793A\u6846'
		),
		_react2.default.createElement('br', null),
		_react2.default.createElement(
			_index2.default.Button,
			{ size: 'sm', secondary: true, onClick: success },
			'success'
		),
		_react2.default.createElement('br', null),
		_react2.default.createElement(
			_index2.default.Button,
			{ size: 'sm', secondary: true, onClick: error },
			'error'
		),
		_react2.default.createElement('br', null),
		_react2.default.createElement(
			_index2.default.Button,
			{ size: 'sm', secondary: true, onClick: warning },
			'waring'
		),
		_react2.default.createElement('br', null),
		_react2.default.createElement(
			_index2.default.Button,
			{ size: 'sm', secondary: true, onClick: loading },
			'loading'
		),
		_react2.default.createElement('br', null)
	);
}

function params() {

	var dataSource = [{
		key: "content",
		type: "string",
		"default": "无",
		mark: "显示的内容"
	}, {
		key: "timeout",
		type: "int",
		"default": "3000",
		mark: "自动关闭的延时，单位毫秒"
	}, {
		key: "onClose",
		type: "function",
		"default": "无",
		mark: "关闭时触发的回调函数"
	}];

	var columns = [{
		title: "参数",
		key: "key"
	}, {
		title: "类型",
		key: "type"
	}, {
		title: "默认值",
		key: "default"
	}, {
		title: "说明",
		key: "mark"
	}];

	return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
	return '\n  \tconst info = function () {\n\t\t\tPIROS.message.info("This is a message of info")\n\t\t};\n\t\tconst success = function () {\n\t\t\tPIROS.message.success(\'This is a message of success\');\n\t\t};\n\t\n\t\tconst error = function () {\n\t\t\tPIROS.message.error(\'This is a message of error,set timeout =1000ms\',1000);\n\t\t};\n\t\n\t\tconst warning = function () {\n\t\t\tPIROS.message.warning(\'This is message of warning\',1000,()=>{\n\t\t\t\tconsole.log(\'\u56DE\u8C03\u51FD\u6570onClose\')\n\t\t\t});\n\t\t};\n\t\n\t\tconst loading = function () {\n\t\t\tPIROS.message.loading(\'This is message of warning\');\n\t\t}\n\t\t<PIROS.Button size="sm" onClick={info}>\n\t\t\t\u666E\u901A\u63D0\u793A\u6846\n\t\t</PIROS.Button>\n\t\t<br/>\n\t\t<PIROS.Button size="sm"  secondary={true} onClick={success}>\n\t\t\tsuccess\n\t\t</PIROS.Button>\n\t\t<br/>\n\t\t<PIROS.Button size="sm"  secondary={true} onClick={error} >\n\t\t\terror\n\t\t</PIROS.Button>\n\t\t<br/>\n\t\t<PIROS.Button size="sm"  secondary={true} onClick={warning}>\n\t\t\twarning\n\t\t</PIROS.Button>\n\t\t<br/>\n\t\t<PIROS.Button size="sm"  secondary={true} onClick={loading}>\n\t\t\tloading\n\t\t</PIROS.Button>\n\t\t\t<br/>\n    ';
}

module.exports = {
	example: example,
	params: params,
	code: code
};
//# sourceMappingURL=Message.js.map