'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  var simpleOkHandle = function simpleOkHandle() {
    _this.setState({
      simpleDisplay: false
    });
  };

  var simpleCancelHandle = function simpleCancelHandle() {
    _this.setState({
      simpleDisplay: false
    });
  };

  var simpleClick = function simpleClick() {
    _this.setState({
      simpleDisplay: true
    });
  };

  var loadingOkHandle = function loadingOkHandle() {
    _this.setState({
      loading: true
    });
    setTimeout(function () {
      _this.setState({
        loadingDisplay: false,
        loading: false
      });
    }, 1000);
  };

  var loadingCancelHandle = function loadingCancelHandle() {
    _this.setState({
      loadingDisplay: false
    });
  };

  var loadingClick = function loadingClick() {
    _this.setState({
      loadingDisplay: true
    });
  };

  var _state = this.state,
      loadingDisplay = _state.loadingDisplay,
      simpleDisplay = _state.simpleDisplay,
      loading = _state.loading;

  if (loadingDisplay === undefined) loadingDisplay = false;
  if (simpleDisplay === undefined) simpleDisplay = false;

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default.Button,
      { onClick: simpleClick },
      'simple'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.Button,
      { onClick: loadingClick },
      'loading'
    ),
    _react2.default.createElement(
      _index2.default.Modal,
      { title: "Modal", enterClick: true, display: simpleDisplay, onOk: simpleOkHandle, onCancel: simpleCancelHandle },
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      ),
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      ),
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      )
    ),
    _react2.default.createElement(
      _index2.default.Modal,
      { title: "Modal", display: loadingDisplay, loading: loading, onOk: loadingOkHandle, onCancel: loadingCancelHandle, maskClick: true, style: { width: "200px" } },
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      ),
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      ),
      _react2.default.createElement(
        'p',
        null,
        'aaaaaaaaaaa'
      )
    )
  );
}

function params() {

  var dataSource = [{
    key: "display",
    type: "bool",
    "default": "false",
    mark: "是否显示"
  }, {
    key: "title",
    type: "string",
    "default": "",
    mark: "显示title"
  }, {
    key: "onOk",
    type: "func",
    "default": "",
    mark: "确定按钮点击方法"
  }, {
    key: "onCancel",
    type: "func",
    "default": "",
    mark: "取消按钮点击方法"
  }, {
    key: "loading",
    type: "bool",
    "default": "false",
    mark: "true时,按钮disable,确定按钮变加载中"
  }, {
    key: "okButtonText",
    type: "string",
    "default": "确定",
    mark: "确定按钮文字"
  }, {
    key: "cancelButtonText",
    type: "string",
    "default": "取消",
    mark: "取消按钮文字"
  }, {
    key: "cancelButton",
    type: "bool",
    "default": "true",
    mark: "显示取消按钮"
  }, {
    key: "footer",
    type: "null|dom",
    "default": "取消和确定按钮",
    mark: "自定义footer"
  }, {
    key: "maskClick",
    type: "bool",
    "default": "false",
    mark: "点击蒙板触发onCancel方法，loading为true时失效"
  }, {
    key: "enterClick",
    type: "bool",
    "default": "false",
    mark: "回车时执行props.onOk方法"
  }, {
    key: "style",
    type: "css object",
    "default": "",
    mark: "样式，作用在modal-content上"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n  let simpleOkHandle = () => {\n    this.setState({\n      simpleDisplay:false,\n    })\n  }\n\n  let simpleCancelHandle = () => {\n    this.setState({\n      simpleDisplay:false,\n    })\n  }\n\n  let simpleClick = () => {\n    this.setState({\n      simpleDisplay:true\n    })\n  }\n  let {simpleDisplay} = this.state;\n  if (simpleDisplay === undefined) simpleDisplay = false\n\n  return <div>\n    <PIROS.Button onClick={simpleClick} >simple</PIROS.Button>\n    <PIROS.Modal title={"Modal"} display={simpleDisplay} onOk={simpleOkHandle} onCancel={simpleCancelHandle}>\n      <p>aaaaaaaaaaa</p>\n      <p>aaaaaaaaaaa</p>\n      <p>aaaaaaaaaaa</p>\n    </PIROS.Modal>\n  </div>\n  \n  \n  \n\n  let loadingOkHandle = () => {\n    // loading\u8BBE\u7F6E\u4E3Atrue, \u5B8C\u6210loading\u7684\u64CD\u4F5C\u540Edisplay\n    this.setState({\n      loading: true\n    })\n    setTimeout(()=>{\n      this.setState({\n        loadingDisplay:false,\n        loading: false\n      })\n    }, 1000)\n  }\n\n  let loadingCancelHandle = () => {\n    // \u9690\u85CF\n    this.setState({\n      loadingDisplay:false,\n    })\n  }\n\n  let loadingClick = () => {\n    // \u663E\u793AModal\n    this.setState({\n      loadingDisplay:true\n    })\n  }\n\n  let {loadingDisplay, loading} = this.state;\n  if (loadingDisplay === undefined) loadingDisplay = false\n\n  return <div>\n    <PIROS.Button onClick={loadingClick} >loading</PIROS.Button>\n    <PIROS.Modal title={"Modal"} display={loadingDisplay} loading={loading} onOk={loadingOkHandle} onCancel={loadingCancelHandle} maskClick\uFF1D{true} style={{width:"200px"}} >\n      <p>aaaaaaaaaaa</p>\n      <p>aaaaaaaaaaa</p>\n      <p>aaaaaaaaaaa</p>\n    </PIROS.Modal>\n  </div>\n    ';
}

module.exports = {
  title: "Modal 对话框",
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Modal.js.map