'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var renderContent = _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'div',
      { style: { backgroundColor: "#ccc" } },
      '\u82DF\u5229\u56FD\u5BB6\u751F\u6B7B\u4EE5'
    ),
    _react2.default.createElement(
      'div',
      { style: { backgroundColor: "#ddd" } },
      '\u5C82\u56E0\u7978\u798F\u907F\u8D8B\u4E4B'
    ),
    _react2.default.createElement(
      'div',
      { style: { backgroundColor: "#eee" } },
      '+1s'
    )
  );
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index.Popconfirm,
      {
        content: renderContent,
        title: '\u6807\u9898\u5185\u5BB9',
        direction: 'top'
      },
      _react2.default.createElement(
        'button',
        { style: { margin: '5px' } },
        '\u4E0A\u65B9\u5F39\u51FA'
      )
    ),
    _react2.default.createElement(
      _index.Popconfirm,
      {
        content: renderContent,
        title: '\u6807\u9898\u5185\u5BB9',
        direction: 'bottom'
      },
      _react2.default.createElement(
        'button',
        { style: { margin: '5px' } },
        '\u4E0B\u65B9\u5F39\u51FA'
      )
    ),
    _react2.default.createElement(
      _index.Popconfirm,
      {
        content: renderContent,
        title: '\u6807\u9898\u5185\u5BB9',
        direction: 'left'
      },
      _react2.default.createElement(
        'button',
        { style: { margin: '5px' } },
        '\u5DE6\u4FA7\u5F39\u51FA'
      )
    ),
    _react2.default.createElement(
      _index.Popconfirm,
      {
        content: renderContent,
        title: '\u6807\u9898\u5185\u5BB9',
        direction: 'right'
      },
      _react2.default.createElement(
        'button',
        { style: { margin: '5px' } },
        '\u53F3\u4FA7\u5F39\u51FA'
      )
    ),
    _react2.default.createElement(
      _index.Popconfirm,
      {
        content: renderContent,
        title: '\u6807\u9898\u5185\u5BB9',
        direction: 'top',
        visible: true
      },
      _react2.default.createElement(
        'button',
        { style: { margin: '5px' } },
        '\u9ED8\u8BA4\u5C55\u73B0'
      )
    )
  );
}

function params() {
  var dataSource = [{
    key: "title",
    type: "string",
    "default": "默认为空",
    mark: "气泡卡片标题，title为空时无标题栏"
  }, {
    key: "direction",
    type: "string",
    "default": "默认为top",
    mark: "弹出方向，可选参数: left | right | top | bottom 默认为top"
  }, {
    key: "content",
    type: "object",
    "default": "默认为空div",
    mark: "传入你要渲染的主内容部分"
  }, {
    key: "visible",
    type: "bool",
    "default": "默认为false",
    mark: "默认显示或隐藏"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n  const renderContent = (\n    <div>\n      <div style={{backgroundColor: "#ccc"}}>\u82DF\u5229\u56FD\u5BB6\u751F\u6B7B\u4EE5</div>\n      <div style={{backgroundColor: "#ddd"}}>\u5C82\u56E0\u7978\u798F\u907F\u8D8B\u4E4B</div>\n      <div style={{backgroundColor: "#eee"}}>+1s</div>\n    </div>\n  );\n\n  <div>\n    <Popconfirm\n      content={renderContent}\n      title="\u6807\u9898\u5185\u5BB9"\n      direction="top"\n    >\n      <button style={{margin: \'5px\'}}>\u4E0A\u65B9\u5F39\u51FA</button>\n    </Popconfirm>\n    <Popconfirm\n      content={renderContent}\n      title="\u6807\u9898\u5185\u5BB9"\n      direction="bottom"\n    >\n      <button style={{margin: \'5px\'}}>\u4E0B\u65B9\u5F39\u51FA</button>\n    </Popconfirm>\n    <Popconfirm\n      content={renderContent}\n      title="\u6807\u9898\u5185\u5BB9"\n      direction="left"\n    >\n      <button style={{margin: \'5px\'}}>\u5DE6\u4FA7\u5F39\u51FA</button>\n    </Popconfirm>\n    <Popconfirm\n      content={renderContent}\n      title="\u6807\u9898\u5185\u5BB9"\n      direction="right"\n    >\n      <button style={{margin: \'5px\'}}>\u53F3\u4FA7\u5F39\u51FA</button>\n    </Popconfirm>\n    <Popconfirm\n      content={renderContent}\n      title="\u6807\u9898\u5185\u5BB9"\n      direction="top"\n      visible={true}\n    >\n      <button style={{margin: \'5px\'}}>\u9ED8\u8BA4\u5C55\u73B0</button>\n    </Popconfirm>\n  </div>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Popconfirm.js.map