'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index2.default.Progress, { progress: 0 }),
    _react2.default.createElement(_index2.default.Progress, { progress: 30 }),
    _react2.default.createElement(_index2.default.Progress, { progress: 50 }),
    _react2.default.createElement(_index2.default.Progress, { progress: 80, type: 'error' }),
    _react2.default.createElement(_index2.default.Progress, { progress: 100, type: 'success' })
  );
}

function params() {

  var dataSource = [{
    key: "progress",
    type: "number",
    default: "0",
    mark: "进度条的进度值"
  }, {
    key: "type",
    type: "string",
    default: "\"\"",
    mark: "进度条类型, 可选值error, success"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    <PIROS.Progress progress={0} />\n    <PIROS.Progress progress={30} />\n    <PIROS.Progress progress={50} />\n    <PIROS.Progress progress={80} type="error" />\n    <PIROS.Progress progress={100} type="success" />\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Progress.js.map