'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var onChange = function onChange(e) {
    console.log("onchange", e);
  };
  var RadioChange = function RadioChange(e) {
    console.log("RadioChange", e);
  };
  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default.Radio,
      { name: '1', defaultChecked: true, value: 1 },
      'Radio'
    ),
    _react2.default.createElement(
      _index2.default.Radio,
      { name: '1', checked: true, value: 2 },
      'A'
    ),
    _react2.default.createElement(
      _index2.default.Radio,
      { disabled: true, value: 1 },
      'Radio'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.RadioGruop,
      { defaultValue: 3, onChange: onChange },
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 1, disabled: true },
        'A'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 2, onChange: RadioChange },
        'B'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 3 },
        'C'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 4 },
        'D'
      )
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      _index2.default.RadioGruop,
      { defaultValue: 1, onChange: onChange },
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 1, disabled: true },
        'A'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 2, onChange: RadioChange },
        'B'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 3 },
        'C'
      ),
      _react2.default.createElement(
        _index2.default.Radio,
        { value: 4 },
        'D'
      )
    )
  );
}

function params() {

  var dataSource = [{
    key: "defaultChecked",
    type: "bool",
    "default": "false",
    mark: "默认选中状态"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: "是否禁用"
  }, {
    key: "onChange",
    type: "function",
    "default": "无",
    mark: "选中状态改变回调函数"
  }, {
    key: "checked",
    type: "bool",
    "default": "无",
    mark: "用ref.checked可以获取选中状态"
  }, {
    key: "value",
    type: "string",
    "default": "无",
    mark: "用ref.value可以获取被选中的radio的值，或者RadioGruop中被选中的值"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    const onChange = (e)=>{\n      console.log("onchange")\n    }\n    const RadioChange = (e)=>{\n      console.log("RadioChange")\n    }\n\n\t\t<PIROS.Radio name="1"  defaultChecked value={1}>Radio</PIROS.Radio>\n\t\t<PIROS.Radio name="1" checked value={2}>A</PIROS.Radio>\n\t\t<PIROS.Radio disabled value={1}>Radio</PIROS.Radio>\n\t\t<br/>\n\t\t<br/>\n\t\t<PIROS.RadioGruop defaultValue={3} onChange={onChange}>\n\t\t\t<PIROS.Radio value={1} disabled >A</PIROS.Radio>\n\t\t\t<PIROS.Radio value={2}  onChange={RadioChange}>B</PIROS.Radio>\n\t\t\t<PIROS.Radio value={3}>C</PIROS.Radio>\n\t\t\t<PIROS.Radio value={4}>D</PIROS.Radio>\n\t\t</PIROS.RadioGruop>\n\t</div>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Radio.js.map