'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  var dataSourceList = ["1111", "1234", "2222", "2345", "54321"];

  var itemSourceList = [{ text: "1111", value: "1" }, { text: "1234", value: "2" }, { text: "2222", value: "3" }, { text: "2345", value: "4" }, { text: "54321", value: "5" }];

  var dataSource = this.state.dataSource;

  var onChange = function onChange(value) {
    var dataSource = dataSourceList.filter(function (item) {
      return item.indexOf(value) >= 0;
    });
    _this.setState({ dataSource: dataSource });
  };

  var itemDataSource = this.state.itemDataSource;

  var onItemChange = function onItemChange(value) {
    value = value.text || value;
    var itemDataSource = itemSourceList.filter(function (data) {
      return data.text.indexOf(value) >= 0;
    });
    _this.setState({ itemDataSource: itemDataSource });
  };

  var onItemSelect = function onItemSelect(item) {
    _this.setState({ itemDataSource: [item] });
  };

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'div',
      { style: { display: "inline-block" } },
      _react2.default.createElement(
        'label',
        null,
        '\u6587\u672C: '
      ),
      _react2.default.createElement(_index2.default.SearchInput, { onChange: onChange, dataSource: dataSource, defaultValue: '1111' })
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement(
      'div',
      { style: { display: "inline-block" } },
      _react2.default.createElement(
        'label',
        null,
        '\u7ED3\u6784: '
      ),
      _react2.default.createElement(_index2.default.SearchInput, { onChange: onItemChange, onSelect: onItemSelect, placeholder: '\u8BF7\u8F93\u5165', dataSource: itemDataSource })
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null)
  );
}

function params() {

  var dataSource = [{
    key: "dataSource",
    type: "array",
    "default": "[]",
    mark: "数据源,如果是对象列表，对象中需要有text字段"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: "是否禁用"
  }, {
    key: "defaultValue",
    type: "string|number",
    "default": "无",
    mark: "默认值"
  }, {
    key: "value",
    type: "string|number",
    "default": "-",
    mark: "当前值"
  }, {
    key: "onChange",
    type: "func",
    "default": "(value, item)=>{}",
    mark: "值改变回调"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n  let dataSourceList = [\n    "1111", "1234", "2222", "2345", "54321"\n  ]\n\n\n  let {dataSource} = this.state;\n  let onChange = (value)=>{\n    <!--\u8BF7\u6C42\u670D\u52A1\u5668\u8FD4\u56DE\u641C\u7D22\u7ED3\u679C-->\n    let dataSource = dataSourceList.filter((item)=>{return item.indexOf(value) >= 0});\n    this.setState({dataSource:dataSource})\n  };\n\n  return <div>\n    <PIROS.SearchInput onChange={onChange} dataSource={dataSource} />\n    <br/>\n  </div>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=SearchInput.js.map