'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {

  var dataSource = [{
    text: "first",
    value: 0
  }, {
    text: "last",
    value: "2"
  }];

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index2.default.Select, { dataSource: dataSource, onChange: function onChange(value, item) {
        console.log(value, item);
      }, placeholder: "请选择" }),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Select, { dataSource: dataSource, value: 0 }),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Select, { dataSource: dataSource, defaultValue: "2" }),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Select, { dataSource: dataSource, disabled: true }),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Select, { dataSource: dataSource, disabled: false, showSearch: true, placeholder: "请选择" }),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null)
  );
}

function params() {

  var dataSource = [{
    key: "dataSource",
    type: "array",
    "default": "[]",
    mark: "数据源"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: "是否禁用"
  }, {
    key: "defaultValue",
    type: "string|number",
    "default": "无",
    mark: "默认值"
  }, {
    key: "value",
    type: "string|number",
    "default": "-",
    mark: "当前值"
  }, {
    key: "onChange",
    type: "func",
    "default": "(value, item)=>{}",
    mark: "值改变回调"
  }, {
    key: "showSearch",
    type: "bool",
    "default": "false",
    mark: "是否带搜索框"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n      import {Select} from \'react-piros\'\n\n      let dataSource = [\n        {\n          text:"first",\n          value:"first"\n        },\n        {\n          text:"last",\n          value:"last"\n        }\n      ];\n\n      <Select dataSource={dataSource}  ></Select>\n\n      <Select dataSource={dataSource} disabled={true} ></Select>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Select.js.map