'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  var dataSource = [{
    id: "111",
    firstName: "lu",
    lastName: "jun"
  }, {
    id: "112",
    firstName: "gao",
    lastName: "bo"
  }];

  var columns = [{
    title: "姓",
    key: "firstName"
  }, {
    title: "名",
    key: "lastName"
  }, {
    title: "全名",
    key: "fullName",
    render: function render(text, item) {
      return item.firstName + item.lastName;
    }
  }];

  var rowSelection = {
    type: "checkbox",
    selectedRowKeys: [1],
    onChange: function onChange(selectedRowKeys, selectedRows) {
      console.log(selectedRowKeys, selectedRows);
    }
  };

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default.Button,
      { onClick: function onClick() {
          _this.refs.table.reset();
        } },
      'reset'
    ),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, ref: 'table', rowKey: 'id', rowSelection: rowSelection, columns: columns })
  );
}

function params() {

  var dataSource = [{
    key: "loading",
    type: "bool",
    "default": "false",
    mark: "显示加载中，只有dataSource长度为0才会显示加载中"
  }, {
    key: "dataSource",
    type: "array",
    "default": "[]",
    mark: "数据源"
  }, {
    key: "columns",
    type: "array",
    "default": "[]",
    mark: "表头"
  }, {
    key: "isIndex",
    type: "bool",
    "default": "false",
    mark: "是否显示行号"
  }, {
    key: "rowSelection",
    type: "object",
    "default": "null",
    mark: "列表可选择配置"
  }];

  var dataSource2 = [{
    key: "type",
    type: "string",
    "default": "checkbox",
    mark: "checkbox|radio, 目前仅支持多选"
  }, {
    key: "selectedRowKeys",
    type: "array",
    "default": "[]",
    mark: "默认选中的行的key值"
  }, {
    key: "onChange",
    type: "func",
    "default": "(selectedRowKeys, selectedRows)={}",
    mark: "选择发生回调函数"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'h2',
      null,
      'Table'
    ),
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns }),
    _react2.default.createElement(
      'h2',
      null,
      'rowSelection'
    ),
    _react2.default.createElement(_index2.default.Table, { dataSource: dataSource2, columns: columns })
  );
}

function code() {
  return '\n      let dataSource = [\n        {\n          key:1,\n          firstName:"lu",\n          lastName:"jun"\n        },\n        {\n          key:2,\n          firstName:"gao",\n          lastName:"bo"\n        }\n      ];\n\n      let columns = [\n        {\n          title:"\u59D3",\n          key:"firstName",\n        },\n        {\n          title:"\u540D",\n          key:"lastName",\n        },\n        {\n          title:"\u5168\u540D",\n          key:"fullName",\n          render(text, item){\n            return item.firstName + item.lastName\n          }\n        }\n      ];\n\n      let rowSelection = {\n          type:"checkbox",\n          selectedRowKeys:[1],\n          onChange:(selectedRowKeys, selectedRows)=>{\n            console.log(selectedRowKeys, selectedRows)\n          }\n      }\n      <div>\n        <PIROS.Button onClick={()=>{this.refs.table.reset()}}>reset</PIROS.Button>\n        <br/>\n        <PIROS.Table dataSource={dataSource} rowSelection={rowSelection} columns={columns}></PIROS.Table>\n      </div>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Table.js.map