'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  this.removeTag = function (tag) {
    console.log("delete tag:", tag);
  };

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default.Tag,
      null,
      '\u9ED8\u8BA4\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'message' },
      '\u6D88\u606F\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'succeed' },
      '\u6210\u529F\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'warning' },
      '\u8B66\u544A\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'error' },
      '\u9519\u8BEF\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { remove: true },
      '\u53EF\u79FB\u9664\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'message', remove: true, onClick: function onClick() {
          _this.removeTag("message");
        } },
      '\u53EF\u79FB\u9664\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'succeed', remove: true, onClick: function onClick() {
          _this.removeTag("succeed");
        } },
      '\u53EF\u79FB\u9664\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'warning', remove: true, onClick: function onClick() {
          _this.removeTag("warning");
        } },
      '\u53EF\u79FB\u9664\u6807\u7B7E'
    ),
    _react2.default.createElement(
      _index2.default.Tag,
      { type: 'error', remove: true, onClick: function onClick() {
          _this.removeTag("error");
        } },
      '\u53EF\u79FB\u9664\u6807\u7B7E'
    )
  );
}

function params() {

  var dataSource = [{
    key: "type",
    type: "string",
    "default": "",
    mark: "可选值 message succeed warning error"
  }, {
    key: "remove",
    type: "bool",
    "default": "false",
    mark: "可移除标签"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    <PIROS.Tag >\n      \u9ED8\u8BA4\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="message">\n     \u6D88\u606F\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="succeed" >\n      \u6210\u529F\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="warning" >\n      \u8B66\u544A\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="error">\n      \u9519\u8BEF\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag remove={true}>\n      \u53EF\u79FB\u9664\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="message" remove={true}>\n      \u53EF\u79FB\u9664\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="succeed"  remove={true}>\n      \u53EF\u79FB\u9664\u6807\u7B7E\n    </PIROS.Tag>\n    <PIROS.Tag type="warning" remove={true}>\n      \u53EF\u79FB\u9664\u6807\u7B7E\n    </PIROS.Tag>\n    \n    <PIROS.Tag type="error"  remove={true}>\n      \u53EF\u79FB\u9664\u6807\u7B7E\n    </PIROS.Tag>\n    ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Tag.js.map