'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title\u8FD9\u662F\u5411\u4E0A\u7684title',
          direction: 'top'
        },
        _react2.default.createElement(
          'button',
          null,
          '\u5411\u4E0A'
        )
      )
    ),
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u5DE6\u7684title',
          direction: 'left'
        },
        _react2.default.createElement(
          'button',
          null,
          '\u5411\u5DE6'
        )
      )
    ),
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u53F3\u7684title',
          direction: 'right'
        },
        _react2.default.createElement(
          'button',
          null,
          '\u5411\u53F3'
        )
      )
    ),
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u4E0B\u7684title',
          direction: 'bottom'
        },
        _react2.default.createElement(
          'button',
          null,
          '\u5411\u4E0B'
        )
      )
    ),
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u4E0B\u7684title',
          direction: 'bottom',
          onEnter: function onEnter() {
            return console.info('弹出');
          }
        },
        _react2.default.createElement(
          'button',
          null,
          '\u5F39\u51FA\u65F6\u7684\u56DE\u8C03,\u89C1console'
        )
      )
    ),
    _react2.default.createElement(
      'div',
      { style: { margin: '10px', display: 'inline-block' } },
      _react2.default.createElement(
        _index.Tooltip,
        {
          title: '\u8FD9\u662F\u5411\u4E0B\u7684title',
          direction: 'bottom',
          onLeave: function onLeave() {
            return console.info('离开');
          }
        },
        _react2.default.createElement(
          'button',
          null,
          '\u6D88\u5931\u65F6\u7684\u56DE\u8C03,\u89C1console'
        )
      )
    )
  );
}

function params() {

  var dataSource = [{
    key: "title",
    type: "string",
    "default": "默认为空",
    mark: "弹出的文字(必传)"
  }, {
    key: "direction",
    type: "string",
    "default": "right",
    mark: "可选参数: left | right | top | bottom 默认为right"
  }, {
    key: "onEnter",
    type: "function",
    "default": "默认为空",
    mark: "触发弹窗时的回调函数"
  }, {
    key: "onLeave",
    type: "function",
    "default": "默认为空",
    mark: "弹窗消失时的回调函数"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    <PIROS.Tooltip\n        title="\u8FD9\u91CC\u662F\u5F39\u7A97\u7684\u63D0\u793A\u4FE1\u606F"\n        direction="right"\n        onLeave={() => console.log(\'\u968F\u4FBF\u4E00\u4E2A\u51FD\u6570\u5BF9\u8C61\')}\n        onEnter={() => console.log(\'\u968F\u4FBF\u4E00\u4E2A\u51FD\u6570\u5BF9\u8C61\')}\n    >\n        <button>\u8FD9\u4E2A\u4E5F\u662F\u5FC5\u987B\u7684\u3002\u3002\u3002</button>\n    </PIROS.Tooltip>\n  ';
}

module.exports = {
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Tooltip.js.map