'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function example() {
  var _this = this;

  var onLoad = function onLoad(response, e) {
    var fileList = _this.state.fileList;

    if (response && response.data && response.data.name) {
      fileList.push({
        name: response.data.name,
        href: 'http://image.yuantutech.com/' + response.data.path + response.data.name
      });
    }
    _this.setState({
      fileList: fileList
    });
    console.log("onLoad response:", response, e);
  };

  var onError = function onError(res, e) {
    console.log("onError :", res);
  };

  var onProcess = function onProcess(e) {
    console.log("onProcess", e);
  };

  var removeFile = function removeFile(file) {
    var fileList = _this.state.fileList;

    console.log(fileList, "remove file:", file);
    if (fileList.indexOf(file) > -1) {
      fileList.splice(fileList.indexOf(file), 1);
    }
    _this.setState({
      fileList: fileList
    });
  };

  var onLoadBase64 = function onLoadBase64(data, e) {
    var Base64List = _this.state.Base64List;

    Base64List.push(data);
    _this.setState({
      Base64List: Base64List
    });
  };

  var removeBase64 = function removeBase64(data) {
    var Base64List = _this.state.Base64List;

    console.log(Base64List, "remove file:", data);
    if (Base64List.indexOf(data) > -1) {
      Base64List.splice(Base64List.indexOf(data), 1);
    }
    _this.setState({
      Base64List: Base64List
    });
  };

  if (this.state.fileList === undefined) {
    this.state.fileList = ['http://image.yuantutech.com/user/d7846bb575a7f446364306052bd2292c-503-444.jpg'];
  }
  if (this.state.Base64List === undefined) {
    this.state.Base64List = [];
  }

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_index2.default.Upload, { action: 'http://tps.yuantutech.com/upload', onLoad: onLoad, onError: onError,
      listType: 'picture', size: { width: 750 }, showProgress: true,
      fileList: this.state.fileList, removeFile: removeFile, accept: 'image' }),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement('br', null),
    _react2.default.createElement(_index2.default.Upload, { action: 'base64', onLoad: onLoadBase64, fileList: this.state.Base64List,
      listType: 'picture', removeFile: removeBase64, accept: 'image' })
  );
}

function params() {

  var dataSource = [{
    key: "action",
    type: "string",
    "default": "",
    mark: "必传，图片上传地址(当action值==='base64'时，返回base64)"
  }, {
    key: "desc",
    type: "string",
    "default": "",
    mark: "显示提示"
  }, {
    key: "onLoad",
    type: "func",
    "default": "",
    mark: "上传成功的回调"
  }, {
    key: "onProgress",
    type: "func",
    "default": "",
    mark: "onProgress"
  }, {
    key: "showProgress",
    type: "bool",
    "default": "false",
    mark: "是否显示上传进度条"
  }, {
    key: "onError",
    type: "func",
    "default": "",
    mark: "error回调"
  }, {
    key: "accept",
    type: "string",
    "default": "",
    mark: "上传文件类型限制"
  }, {
    key: "customRequest",
    type: "func",
    "default": "",
    mark: "自定义上传方法"
  }, {
    key: "disabled",
    type: "bool",
    "default": "false",
    mark: "是否失效"
  }, {
    key: "withCredentials",
    type: "bool",
    "default": "true",
    mark: "是否携带cookie（使用CORS时）"
  }, {
    key: "fileList",
    type: "array",
    "default": "[]",
    mark: "文件列表['a.png',{name:'b.png', href:'http://xxx/b.png'}]，对象时点击可打开新页面查看图片"
  }, {
    key: "removeFile",
    type: "func",
    "default": "",
    mark: "删除文件回调"
  }];

  var columns = [{
    title: "参数",
    key: "key"
  }, {
    title: "类型",
    key: "type"
  }, {
    title: "默认值",
    key: "default"
  }, {
    title: "说明",
    key: "mark"
  }];

  return _react2.default.createElement(_index2.default.Table, { dataSource: dataSource, columns: columns });
}

function code() {
  return '\n    let onLoad = (response, e) => {\n      let {fileList} = this.state;\n      if (response && response.data && response.data.name){\n        fileList.push({\n          name:response.data.name,\n          href:`http://image.yuantutech.com/${response.data.path}${response.data.name}`\n      })\n    }\n    this.setState({\n      fileList\n    })\n    console.log("onLoad response:", response, e)\n    }\n\n\n    let onError = (res, e) => {\n      console.log("onError :", res)\n    }\n\n    let onProcess = (e) => {\n      console.log("onProcess",e)\n    }\n\n    let removeFile = (file) =>{\n      let {fileList} = this.state;\n      console.log(fileList,"remove file:", file)\n      if (fileList.indexOf(file) > -1){\n        fileList.splice(fileList.indexOf(file), 1)\n      }\n      this.setState({\n        fileList\n      })\n    }\n\n    let onLoadBase64 = (data, e) =>{\n      let {Base64List} = this.state;\n      Base64List.push(data)\n      this.setState({\n        Base64List\n      })\n    }\n\n    let removeBase64 = (data) =>{\n      let {Base64List} = this.state;\n      console.log(Base64List,"remove file:", data)\n      if (Base64List.indexOf(data) > -1){\n        Base64List.splice(Base64List.indexOf(data), 1)\n      }\n      this.setState({\n        Base64List\n      })\n    }\n\n\n    if (this.state.fileList === undefined){\n      this.state.fileList=[\'http://image.yuantutech.com/user/d7846bb575a7f446364306052bd2292c-503-444.jpg\']\n    }\n    if (this.state.Base64List === undefined){\n      this.state.Base64List=[]\n    }\n\n    return <div>\n      <PIROS.Upload action="http://tps.yuantutech.com/upload" onLoad={onLoad} onError={onError} onProcess={onProcess}\n                    listType="picture" size={{width:361}} fileList={this.state.fileList} removeFile={removeFile}  accept="image"/>\n      <br/>\n      <br/>\n      <br/>\n      <br/>\n      <PIROS.Upload action="base64" onLoad={onLoadBase64}  fileList={this.state.Base64List}\n                    listType="picture" removeFile={removeBase64}  accept="image"/>\n    </div>\n    ';
}

module.exports = {
  title: "Upload 上传",
  example: example,
  params: params,
  code: code
};
//# sourceMappingURL=Upload.js.map