import React from 'react'
import PropTypes from 'prop-types'

export default class Alert extends React.Component {
  
  static propTypes = {
    type:PropTypes.string,
    remove:PropTypes.bool,
    icon:PropTypes.bool,
    title:PropTypes.string,
    description:PropTypes.bool,
  };

  constructor(props) {
    super(props);
    
    this.typeEnum = {
      "info":"alert alert-info",
      "success":"alert alert-success",
      "warning":"alert alert-warning ",
      "error":"alert alert-error",
    }
    this.state={display: false}

  }

  onClick(e){
    this.setState({
      display: true 
    })
    this.props.onClick && this.props.onClick(e)
  }
  render(){
    let {type, remove,title,icon,description} = this.props;
    let {display} = this.state;
    let className = this.typeEnum[type] || this.typeEnum["default"];
    let iconlg
    if (description) {
      className = className + " alert-with-description"
      if(!icon){
        className = className + " alert-no-icon"
      }else {
        
        iconlg = icon;
        icon=false;
      }

    }

    return (
      <div className={className + ( display ? " hide" :"")  } >
        {
          icon ? <span className="alert-icon-circle"></span> : ""
        }
        {
          iconlg ? <span className="alert-icon-circle-lg"></span> : ""
        }
        <span className="alert-message">{title}</span>
        {
          description ? <p className="alert-description">{this.props.children}</p> :""
        }
        {
          remove ? <span className="alert-icon-close" onClick={this.onClick.bind(this)}></span> : null
        }
      </div>
    )
  }

  
}


