import React from 'react'
import PropTypes from 'prop-types'

export default class Badge extends React.Component {
  
  static propTypes = {
    type:PropTypes.string,
    wrapper:PropTypes.bool,
  };

  constructor(props) {
    super(props);
    
    this.typeEnum = {
      "default":"badge",
      "muted":"badge badge-muted",
      "weaker":"badge badge-weaker",
    }

  }

  render(){
    let {type, wrapper} = this.props;
    let className = this.typeEnum[type] || this.typeEnum["default"];
    return (
      
        wrapper ? <span className="badge-wrapper"> {this.props.children} 
          <span className="badge"></span>
        </span> : <span className = {className}>
         {this.props.children}</span>
      
    )
  }

  
}


