import React from 'react'
import PropTypes from 'prop-types'

export default class Button extends React.Component {
  
  static propTypes = {
    size:PropTypes.string,
    disabled:PropTypes.bool,
    loading:PropTypes.bool,
    secondary:PropTypes.bool,
  };

  constructor(props) {
    super(props);
    this.sizeEnum = {
      "default":"btn",
      "lg":"btn btn-lg",
      "sm":"btn btn-sm",
    }
    this.state = {
      isAction:true
    }
  }

  onClick(e){
    this.props.onClick && this.props.onClick(e)
  }

  render(){
    let {size, loading, disabled , secondary, style} = this.props;
    let className = this.sizeEnum[size] || this.sizeEnum["default"];
    className = secondary? className+" btn-secondary" : className; //次级按钮
    return (
      <button className={className} style={style} disabled={disabled ? "disabled":false} onClick={this.onClick.bind(this)} >
        {
          loading ? <span className="loading"></span> : null
        }
        {this.props.children}
      </button>
    )
  }

}


