import React, {Component}from 'react';
import PropTypes from 'prop-types'
// import { listeners } from 'cluster';
import moment from 'moment'
export default class DatePicker extends Component {

	static propTypes = {
		defaultValue:PropTypes.string,
		disabled:PropTypes.bool,
		showTime: PropTypes.bool,
    disabledDate:PropTypes.func,
		placeholder:PropTypes.string,
		onChange:PropTypes.func,
		onOpenChange:PropTypes.func
	};

	constructor(props) {
		super(props);
		this.date = props.defaultValue?new Date(props.defaultValue.replace(/-/g, '/')):new Date();
		this.needOnchange = false;//通过这个参数判断onBlur是否要触发onchange事件
		this.state = {
			isShowPicker:false,
			isShowTime: false,
			showYear: this.date.getFullYear(),
			showMonth: this.date.getMonth()+1,
			showDay: this.date.getDay(),
			selectedYear: 0,
			selectMonth: 0,
			selectedDay: 0,
			date: props.defaultValue?moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD'):''
		}
	}
	componentWillReceiveProps(props){
		if(props.date){
			this.date =new Date(props.date);
			this.setState({
				showYear: this.date.getFullYear(),
				showMonth: this.date.getMonth()+1,
				showDay: this.date.getDay(),
				selectedYear: this.date.getFullYear(),
				selectMonth: this.date.getMonth()+1,
				selectedDay: this.date.getDay(),
				date: moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD')
			})
		}
	}

    handleDisabledDate(year, month, day, style, func){
		const monthMinus1 = month-1 == 0? 12: month-1
        const currentMillionSeconds = new Date().setFullYear(year, monthMinus1, day);
        if(func && func(currentMillionSeconds)){
            style += " calendar-disabled-cell"
        }
        return style
	}

	/*算某个月的总天数*/
	getdaysinonemonth(year,month){
		month=parseInt(month,10);
		var d=new Date(year,month,0);
		return d.getDate();
	}

	/*算某个月的第一天是星期几*/
	getfirstday(year,month){
		month=month-1;
		var d=new Date(year,month,1);
		return d.getDay();
	}

	datePut(year,month) {
		var {selectedYear,selectedMonth,selectedDay} = this.state;
		const prevMonth = month-1 == 0? 12: month-1
		const nextMonth = month == 12 ? 1: month+1;
		var firstDay = this.getfirstday(year,month),
			/*monthCount: 某个月的总天数*/
			monthCount = this.getdaysinonemonth(year,month),
			preMonthCount = this.getdaysinonemonth(year, prevMonth);
		var now = new Date(),
			nowYear = now.getFullYear(),
			nowMonth = now.getMonth()+1,
			nowDay = now.getDate();
		var day = 1;
		var start = false;
		var html =[];
		for(var i = 1; i < 7; i++){        //下拉框的行数，共六行
			var td = [];
			if (i == 1 && firstDay!=7){    //上个月
				for(var k = firstDay-1; k >= 0; k--){
					const currentYear = prevMonth==1?year-1:year;
					let style='calendar-cell calendar-last-month-cell';
					style = this.handleDisabledDate(currentYear, prevMonth, preMonthCount, style, this.props.disabledDate);
					td.unshift(<td key={i+"-"+k} className={style} onMouseDown={this.selected.bind(this,year,month,preMonthCount,"prev", style)}><div className='calendar-date'>{preMonthCount}</div></td>);
					preMonthCount--;
				}
			}
			for (var j = 0; j < 7; j++){   //下拉框每一行中有七天，从周日到周六
				if (i == 1 && !start){     //第一行 当前月第一天
					if ((firstDay == 7 && j == 0) || firstDay == j){
						let style = "calendar-cell ";
						if(day==nowDay && month == nowMonth && year==nowYear) {
							style += "calendar-today ";
						}
						if(day==selectedDay && month == selectedMonth && year==selectedYear){
							style += "calendar-selected-day "
						}
                        style = this.handleDisabledDate(year, month, day, style, this.props.disabledDate);
                        td.push(<td key={i+"-"+j} className={style} onMouseDown={this.selected.bind(this,year,month,day,"this", style)}><div className='calendar-date'>{day}</div></td>);
						day ++;
						start = true;
					}
				} else if (start && day <= monthCount){   //当前月
					let style = "calendar-cell ";
					if(day==nowDay && month == nowMonth && year==nowYear) {
						style += "calendar-today ";
					}
					if(day==selectedDay && month == selectedMonth && year==selectedYear){
						style += "calendar-selected-day "
					}
                    style = this.handleDisabledDate(year, month, day, style, this.props.disabledDate);
                    td.push(<td key={i+"-"+j} className={style} onMouseDown={this.selected.bind(this,year,month,day,"this", style)}><div className='calendar-date'>{day}</div></td>);
					day ++;
				} else if (start && day > monthCount){    //当前月的下个月
					const currentYear = month == 12? year+1: year
                    let style = "calendar-cell calendar-last-month-cell";
                    style = this.handleDisabledDate(currentYear, nextMonth, day-monthCount, style, this.props.disabledDate);
					td.push(<td key={i+"-"+j} className={style} onMouseDown={this.selected.bind(this,year,month,day-monthCount,"next", style)}><div className='calendar-date'>{day-monthCount}</div></td>);
					day ++;
				}
			}
			html.push(<tr key={html.length}>{td}</tr>)
		}
		return html;
	}

	getDataTable() {
		var {showYear,showMonth} = this.state;
		var thead = [];
		let { showTime } = this.props
		thead.push(
			<thead key={thead.length}>
			<tr>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>日</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>一</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>二</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>三</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>四</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>五</span></th>
				<th className='calendar-column-header'> <span className='calendar-column-header-inner'>六</span></th>
			</tr>
			</thead>
		);
		return (
			<div className='calendar-picker-panel'>
				<div className='calendar-picker-date-panel'>
					<div className='calendar-hearder'>
						<a className='calendar-prev-year-btn' onMouseDown={(e)=>{
							e.preventDefault();
							this.dateChange("year","prev")}}> </a>
						<a className='calendar-prev-month-btn' onMouseDown={(e)=>{
							e.preventDefault();
							this.dateChange("month","prev")}}> </a>
						<span className='calendar-my-select'>
                                <a className='calendar-year-select txt-link'>{showYear}年</a>
                                <a className='calendar-month-select txt-link'>{showMonth}月</a>
                            </span>
						<a className='calendar-next-month-btn' onMouseDown={(e)=>{
							e.preventDefault();
							this.dateChange("month","next")}}> </a>
						<a className='calendar-next-year-btn' onMouseDown={(e)=>{
							e.preventDefault();
							this.dateChange("year","next")}}> </a>
					</div>
					<div className='calendar-body'>
						<table className='calendar-table'>
							{thead}
							<tbody className='calendar-tbody'>
							{this.datePut(showYear,showMonth)}
							</tbody>
						</table>
					</div>
					
					<div className='calendar-footer'>
						<a className={showTime?'calendar-moment-btn txt-link':'calendar-today-btn txt-link'} onMouseDown={(e)=>{
							e.preventDefault();
							this.today()}}>今天</a>
						{showTime?<a className='calendar-time-select-btn txt-link select-time' onMouseDown={(e)=>{
							e.preventDefault();
							this.selectTime()}}>选择时间</a>:null}
					</div>
				</div>
			</div>
		);
	}
	timeSelect(type, value, e) {
		if(type == 'second') document.activeElement.blur();
		let { date } = this.state
		this.date = moment(date)[type](value).format('YYYY-MM-DD HH:mm:ss')
		this.setState({
			date: moment(date)[type](value).format('YYYY-MM-DD HH:mm:ss'),
			isShowPicker: type == 'second'?false:true,
			isShowTime: type == 'second'?false:true,
		})
	}
	getTimeTable() {
		let { date } = this.state
		let timeArr = ["00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59"]
		let hour = moment(date).hour()
		let minute = moment(date).minute()
		let second = moment(date).second()
		return(
			<div className="calendar-picker-panel" type="time" style={{ height: '322px'}}> 
				<div className="calendar-picker-date-panel">
					<div className="calendar-hearder">
						{ date }
					</div>
					<div className="calendar-time"> 
						<div className="calendar-time-panel"> 
							<div className="time-picker-combobox-wrapper" onMouseDown={(e)=>{e.preventDefault();}}>
								<div className="time-picker-select" type="hour">
									<ul>
										{ 
											timeArr.map(item => {
												return <li className={ item == hour?'item-action':'' } key={ item } onClick={ this.timeSelect.bind(this, 'hour', item) }>{ item }</li>
											})
										}
									</ul>
								</div>
								<div className="time-picker-select" type="minute">
									<ul>
										{ 
											timeArr.map(item => {
												return <li className={ item == minute?'item-action':'' } key={ item } onClick={ this.timeSelect.bind(this, 'minute', item) }>{ item }</li>
											})
										}
									</ul>
								</div>
								<div className="time-picker-select" type="second">
									<ul>
										{ 
											timeArr.map(item => {
												return <li className={ item == second?'item-action':'' } key={ item } onClick={ this.timeSelect.bind(this, 'second', item) }>{ item }</li>
											})
										}
									</ul>
								</div>
							</div>
						</div>
					</div>
					<div className="calendar-footer"> 
						<a className="calendar-moment-btn txt-link" onMouseDown={ (e) => {
							e.preventDefault();
							let { date } = this.state
							date = moment(date).second(moment().second())
							date = moment(date).minute(moment().minute())
							date = moment(date).hour(moment().hour())
							this.setState({
								date: date.format('YYYY-MM-DD HH:mm:ss')
							})
						} }>此刻</a>
						<a style={{ marginLeft: '70px' }} className="txt-link select-date" onMouseDown={ (e) => {
							e.preventDefault();
							this.setState({ isShowTime: false })
						} }>选择日期</a> 
						<a style={{ marginLeft: '10px' }} className="txt-link select-date" onMouseDown={ (e) => {
							e.preventDefault();
							this.setState({ isShowTime: false, isShowPicker: false })
						} }>确定</a> 
					</div> 
				</div> 
			</div>
		)
	}
	// show(){
	// 	var {isShowPicker} = this.state;
	// 	if(this.props.disabled){
	// 		return ;
	// 	}
	// 	this.setState({
	// 		isShowPicker: !isShowPicker
	// 	});
	// 	this.props.onOpenChange&&this.props.onOpenChange(!isShowPicker);
	// }

	selected(year, month, day, type, style, e){

		if(this.props.showTime) e.preventDefault();
		if(style.indexOf("calendar-disabled-cell") > 0) return false;
		var selectedYear,selectedMonth,selectedDay;
		if(type=="this"){
			selectedYear = year;
			selectedMonth = month;
			selectedDay = day;
		}else if(type=="prev"){
			selectedYear = month==1?year-1:year;
			selectedMonth = month==1?12:month-1;
			selectedDay = day;
		} else if(type=="next"){
			selectedYear = month==12?year+1:year;
			selectedMonth = month==12?1:month+1;
			selectedDay = day;
		}
		if (this.props.showTime) {
			this.date = new Date(selectedYear,selectedMonth-1,selectedDay, new Date().getHours(), new Date().getMinutes(), new Date().getSeconds());
		} else {
			this.date = new Date(selectedYear,selectedMonth-1,selectedDay);
		}
		this.setState({
			isShowTime: this.props.showTime,
			selectedYear: selectedYear,
			selectedMonth: selectedMonth,
			selectedDay: selectedDay,
			showYear: selectedYear,
			showMonth: selectedMonth,
			date: moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD')
		});
	}

	deleteTime(){
		this.setState({
			selectedYear: 0,
			selectedMonth: 0,
			selectedDay: 0,
			date: ""
		});
		this.onChange();
	}

	dateChange(type,direction){
		var {showYear,showMonth} = this.state;
		var year,month;
		if(type == 'year' && direction == 'prev'){
			year = showYear-1;
			month = showMonth;
		} else if(type == 'year' && direction == 'next'){
			year = showYear + 1;
			month = showMonth;
		} else if(type == 'month' && direction == 'prev'){
			year = showMonth==1? showYear - 1: showYear;
			month = showMonth==1? 12: showMonth -1;
		} else if(type == 'month' && direction == 'next'){
			year = showMonth==12? showYear + 1: showYear;
			month = showMonth==12? 1: showMonth + 1;
		}
		this.setState({
			showYear: year,
			showMonth: month,
		});
	}

	today(){
		var now = new Date(),
			nowYear = now.getFullYear(),
			nowMonth = now.getMonth()+1,
			nowDay = now.getDate();
		this.date = now;
		this.setState({
			showYear: nowYear,
			showMonth: nowMonth,
			showDay: nowDay,
			selectedDay: nowDay,
			selectedMonth: nowMonth,
			selectedYear: nowYear,
			date: moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD')
		});
	}
	selectTime() {
		this.setState({
			isShowTime: true
		})
	}
	onChange(){
		this.needOnchange = false;
		this.props.onChange&&this.props.onChange(this.date);
	}

	inputOnChange(e){
		let date = this.refs.date.value;
		this.setState({
			date : date
		})
	}

	onFocus(){//聚焦
		if(this.props.disabled){
			return ;
		}
		this.setState({
			isShowPicker: true
		});
		this.props.onOpenChange&&this.props.onOpenChange(true);
	}

	onBlur(){//失去焦点
		var {date} = this.state;
		if(new Date(date) !='Invalid Date'){
			this.date = new Date(date);
			this.setState({
				showYear: this.date.getFullYear(),
				showMonth: this.date.getMonth()+1,
				showDay: this.date.getDate(),
				selectedYear: this.date.getFullYear(),
				selectedMonth: this.date.getMonth()+1,
				selectedDay: this.date.getDate(),
				date: moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD')
			});
		}
		this.setState({
			date:moment(this.date).format(this.props.showTime?'YYYY-MM-DD HH:mm:ss':'YYYY-MM-DD'),
			isShowPicker:false,
		})
		this.props.onOpenChange&&this.props.onOpenChange(false);
		this.onChange();
	}
	onKeyDown(e){
		// if(e.which == 13){
		// 	this.show()
		// }
		// this.needOnchange = true;

		this.props.onKeyDown&&this.props.onKeyDown()
	}

	render() {
		var {isShowPicker,date, isShowTime} = this.state;
		var style = isShowPicker?"calendar-picker  calendar-picker-action calendar-single-picker":"calendar-picker  calendar-single-picker";
		style += (this.props.disabled?" calendar-picker-disabled":"");
		style += (this.props.showTime?" calendar-time-picker":"");
		return (
			<div className={style}>
				<div className="calendar-picker-input-wrapper">
					<input type="text" name="" className="calendar-picker-input" placeholder={this.props.placeholder||"请选择时间"} value={date}
					       onChange={(e)=>{this.inputOnChange(e)}}
					       onBlur={()=>{this.onBlur()}}
					       onKeyDown={(e)=>{this.onKeyDown(e)}}
					       onFocus={()=>{
					       	this.onFocus()
					       }}
					       ref="date"
					/>
					<span className="icon-calendar-picker" onMouseDown={(e)=>{
						isShowPicker&&e.preventDefault();
						isShowPicker&&this.deleteTime()}}></span>
				</div>
				{isShowTime?this.getTimeTable():this.getDataTable()}
			</div>
		);
	}
}