import React from 'react'
import PropTypes from 'prop-types'

export default class Button extends React.Component {
  
  static propTypes = {
    type:PropTypes.string,
    size:PropTypes.string,
    color:PropTypes.string,
    backgroundColor:PropTypes.string,

  };

  constructor(props) {
    super(props);
    this.typeEnum = {
      "info":"info ",
      "solid-info":"info",
      "success":"success",
      "solid-success":"solid-success",
      "warning":"warning",
      "solid-warning":"solid-warning",
      "error":"error",
      "solid-error":"solid-error",
      "rollback":"rollback",
      "upload":"upload",
      "clip":"clip",
      "remove":"remove",
      "add":"add",
      "see":"see",
      "delete":"delete",
      "reorder":"reorder",
      "ascending":"ascending",
      "descending":"descending",
      "edit":"edit",
      "filter":"filter",
      "user-manage":"user-manage",
      "virtual":"virtual",
      "operation-monitoring":"operation-monitoring",
      "appointment":"appointment",
      "online-interview":"online-interview",
      "mobile-app":"mobile-app",
      "p-user-manage":"p-user-manage",
      "p-virtual":"p-virtual",
      "p-operation-monitoring":"p-operation-monitoring",
      "p-appointment":"p-appointment",
      "p-online-interview":"p-online-interview",
      "p-mobile-app":"p-mobile-app",
      "p-issue-tracking":"p-issue-tracking",
      "p-outpatient-selfservice":"p-outpatient-selfservice",
      "p-clinic-settlement":"p-clinic-settlement",
      "p-smart-queuing":"p-smart-queuing",
      "p-inpatient-terminals":"p-inpatient-terminals",
      "p-inpatient-tv":"p-inpatient-tv",
      "p-healtmanagement":"p-healtmanagement",
      "selected":"selected",
      "search":"search",
      "clear":"clear",
      "date":"date",
      "time":"time",
      "double-down":"double-down",
      "double-up":"double-up",
      "double-left":"double-left",
      "double-right":"double-right",
      "up":"up",
      "down":"down",
      "left":"left",
      "right":"right",
      "fold":"fold",
      "unfold":"unfold",
      "editor-pic":"editor-pic",
      "editor-code":"editor-code",
      "editor-italic":"editor-italic",
      "editor-numlist":"editor-numlist",
      "editor-list":"editor-list",
      "editor-bold":"editor-bold",
      "editor-heading":"editor-heading",
      "editor-quote":"editor-quote",



    }
  }

  render(){
    let {type, size, color ,backgroundColor} = this.props;
    let className = this.typeEnum[type];
    className = "pirosicon pirosicon-"+className; //次级按钮
    return (
      <span className={className} style={{fontSize:size,color:color,backgroundColor:backgroundColor}}>
      </span>
    )
  }

}