import React from 'react'
import PropTypes from 'prop-types'

export default class Input extends React.Component {

	static propTypes = {
		type:PropTypes.string,
		disabled:PropTypes.bool,
		defaultValue:PropTypes.string,
		onChange:PropTypes.func,
		width:PropTypes.string,
		height:PropTypes.string,
	};

	constructor(props) {
		super(props);
		this.value = props.defaultValue || "";
	}

	componentWillReceiveProps(props){
		if(props.value){
			this.value = props.value;
			// this.refs['input'].value = this.value;
		}
	}
	onChange(e){
		this.value = this.refs['input'].value;
		this.props.onChange && this.props.onChange(this.value)
	}

	reset(){
		this.value = "";
    this.refs['input'].value = "";
	}

	render(){
		let {addonAfter,onChange, width, height, ...props} = this.props;
		let type = this.props.type;
		if(addonAfter){
			return (
					<div className="form-search" style={{width,height}}>
						<input ref="input"  className="input"  {...props} onChange={this.onChange.bind(this)}/>
						{addonAfter}
					</div>
				)
		}else if(type=="search"){
			return (
				<div className="form-search" style={{width,height}}>
					<input ref="input"  className="input"  {...props} onChange={this.onChange.bind(this)}/>
					<span className="submit-wrapper"></span>
				</div>
			)
		}else{
			return(
			<input ref="input"  className="input"  {...props}  onChange={this.onChange.bind(this)}/>
			)
		}
	}
}
