import React from 'react'
import PropTypes from 'prop-types'


export default class Layout extends React.Component {
  static propTypes = {
    title: PropTypes.string,
  }
  constructor(props) {
    super(props);
    this.state = {
      title:props.title || "PIROS",
      isShowSide:true
    }
  }

  onSideTrigger(){
    this.setState({isShowSide:!this.state.isShowSide})
  }

  render(){

    let {title, isShowSide} = this.state;
    
    return (
      <div className="yt-main-product">
        {
          React.Children.map( this.props.children, ( element,index ) => {
            return React.cloneElement(element, {isShowSide:isShowSide, title:title, onSideTrigger:this.onSideTrigger.bind(this)})
          })
        }
      </div>
    )
  }

}

//侧边栏
class Side extends React.Component{

  render(){
    let {isShowSide, title, onSideTrigger} = this.props;
    let platformClassName = isShowSide ? "platform-nav-scene platform-action" : "platform-nav-scene";
    let sideClassName =  isShowSide ? "unfoldicon-left" : "unfoldicon-right";
    
    return <div className={platformClassName} style={{position:"fixed"}}>
      <span className={sideClassName} onClick={onSideTrigger}></span> 
      <div className="platform-nav-title">{title}</div>
      <div className="product-wrapper">
        {this.props.children}
      </div>
    </div>
  }
}

//内容区域
class Context extends React.Component{
  render(){
    let {isShowSide} = this.props;
    let innerClassName = isShowSide ? "inner-con inner-con-action" : "inner-con";
    
    return <div className={innerClassName}>
      {this.props.children}
    </div>
  }
}

Layout.Side = Side;
Layout.Context = Context;







