import React from 'react'
import PropTypes from 'prop-types'

export default class Panel extends React.Component {
  
  static propTypes = {
    title:PropTypes.string.isRequired,
    isOpen:PropTypes.bool,
    defaultOpen:PropTypes.bool,
  };

  constructor(props) {
    super(props);
    this.state = {
      isAction:true
    }
  }
  onAction(){
    this.setState({
      isAction:!this.state.isAction
    })
  }
  render(){

    let {isAction} = this.state;
    let panelClassName = isAction ? "yt-panel panel-action" : "yt-panel";

    return (
      <div className={panelClassName}>
        <div className="panel-title"  onClick={this.onAction.bind(this)} >
          {this.props.title}
          <span className="icon-caret panel-caret"></span>
        </div>
        <div className="panel-body">
          {this.props.children}  
        </div>
      </div>
    )
  }

}


