import React from 'react'
import PropTypes from 'prop-types'

class Progress extends React.Component {
  static defaultProps = {
    type: '',
    progress: 0
  }
  
  static propTypes = {
    progress: PropTypes.number.isRequired,
    type: PropTypes.string
  }

  constructor(props) {
    super(props)
  }

  render() {
    let { progress, type } = this.props
    type = type ? `progress-status-${type}` : ''
    return (
      <div className={`progress progress-line ${type}`}>
        <div className="progress-outer">
          <div className="progress-inner">
            <div className="progress-bg" style={{width: `${progress}%`}}></div>
          </div>
          <span className="progress-text">
            {
              type ? '' : `${progress}%`
            }
          </span>
        </div>
      </div>
    )
  }
}

export default Progress