import React from 'react'
import PropTypes from 'prop-types'
import RadioGroup from './RadioGroup'

export default class Radio extends React.Component {

	static propTypes = {
		disabled:PropTypes.bool,
		defaultChecked:PropTypes.bool,
		defaultValue:PropTypes.any,
		onChange:PropTypes.func,
		children:PropTypes.string,
		checked:PropTypes.bool
	};

	constructor(props) {
		super(props);
		this.state={checked : props.defaultChecked || false}
		this.checked = props.defaultChecked || false;
		this.value = props.value;
	}

	componentWillReceiveProps(props){
		if(props.checked){
			this.checked = props.checked;
			this.refs['input'].checked = props.checked;
		}
	}
	onChange(){
		if(this.props.disabled) {
			return ;
		}
		this.checked = this.refs['input'].checked;
		this.props.onChange && this.props.onChange()
	}
	render(){
		var {children,disabled,name,value} = this.props;
		return (
			<label className={"radio-wrapper "+(disabled?"radio-disabled":"")}>
				<input type="radio" ref="input" name={name} disabled={disabled} value={value} defaultChecked={this.props.defaultChecked} onChange={()=>{this.onChange()}}/>{children}
			</label>
		)
	}
}


class Button extends React.Component{
	constructor(props) {
		super(props);
		this.state={checked : props.defaultChecked || false}
		this.checked = props.defaultChecked || false;
		this.value = props.value;
	}
	render() {
		return (
				<label className="radio-button-wrapper">
					<input type="radio" name="radio"/>上海
				</label>

		)
	}
}

Radio.Button = Button;
