import React from 'react'
import PropTypes from 'prop-types'
import Radio from './Radio'

export default class RadioGroup extends React.Component {

	static propTypes = {
		disabled:PropTypes.bool,
		defaultChecked:PropTypes.bool,
		defaultValue:PropTypes.any,
		onChange:PropTypes.func,
	};

	constructor(props) {
		super(props);
		this.value = props.defaultValue;
		this.name = props.name || ("R_"+Math.floor(Math.random()*10000000).toString(36))
	}
	componentDidMount(){

	}

	componentWillReceiveProps(props){
		if(props.value){
			this.value = props.value;
			this.onChange('',props.value)
		}

	}

	onChange(key,value){
		var {children} = this.props;
		for(var i=0;i<children.length;i++){
			if(key) {
				if (key != 'radios' + i) {
					this.refs['radios' + i].checked = false;
				}
			}else if(value){
				if (children[i].props.value != value) {
					this.refs['radios' + i].checked = false;
				}else if(children[i].props.value == value){
					this.refs['radios' + i].checked = true;
				}
			}
		}
		if(key){this.value = this.refs[key].value;}
		this.props.onChange && this.props.onChange(this.value)
	}


	getRadios(){
		var {children,defaultValue} = this.props;
		var Radios = children.map((v,k)=>{
			let {value,children} = v.props;
			return <Radio key={k} ref={'radios'+k} {...v.props} defaultChecked={value==defaultValue?true:false} name={this.name} onChange={()=>{
				this.onChange('radios'+k);
				v.props.onChange && v.props.onChange()
			}}>{children}</Radio>
		}) || [];
		return Radios;
	}
	render(){

		return (
			<div >
				{this.getRadios()}
			</div>
		)
	}
}

