import React from 'react'
import PropTypes from 'prop-types'

export default class Switch extends React.Component {

	static propTypes = {
		disabled:PropTypes.bool,
		defaultChecked:PropTypes.bool,
		checked:PropTypes.bool,
		defaultValue:PropTypes.string,
		onChange:PropTypes.func,
	};

	constructor(props) {
		super(props);
		this.state={checked : props.defaultChecked || props.checked||false}
		this.checked = props.defaultChecked || props.checked||false
	}

	componentWillReceiveProps(props){
		if(props.checked!==undefined){
			this.setState({
				checked:props.checked
			})
			this.checked=props.checked;
			this.refs['input'].checked = props.checked
		}
	}

	onChange(e){
		var {checked} = this.state;
		if(this.props.disabled) {
			return ;
		}
		this.refs['input'].checked = !checked;
		this.setState({
			checked: !checked
		})
		this.props.onChange && this.props.onChange(!checked)
	}


	render(){
		var {disabled} = this.props
		var {checked} = this.state;
		return (
			<span  className={"checkbox-switch " +(checked?"switch-on ":"switch-off ")+(disabled?"switch-disabled":null)} onClick={this.onChange.bind(this)}>
        <span className="switch" > </span>
        <input className="input" ref="input" type="checkbox" {...this.props}/>
			</span >
		)
	}
}
