import React from 'react'
import PropTypes from 'prop-types'

export default class Tabs extends React.Component {
    
    constructor(props){
        super(props);
        this.state = { 
            currentIndex : props.defaultActiveKey || 0, 
        }
    }
    onChange (element,index ) { 
        if (element.props.disabled) {
            return false;
        }
        this.setState({ currentIndex : index })
     } 
    
    render(){
        return(
            <div className="tabs-wrapper">
                { /* 动态生成Tab导航 */ }
                
                <div className="tabs-nav-container">
                    <div className="tabs-nav-wrapper">
                        <div className="tabs-nav">
                            { 
                                React.Children.map( this.props.children , ( element,index ) => {
                                    return(
                                        <div 
                                          onClick={()=>{this.onChange(element,index)}} 
                                          className={"tabs-tab-item " + (index == this.state.currentIndex ? "tabs-tab-item-action " : "")  +( element.props.disabled ? "tabs-tab-item-disabled" :"")} 
                                        >
                                          { element.props.tabNavItem }
                                        </div>
                                    )
                                }) 
                            }
                        </div>
                    </div>
                </div>
                { /* Tab内容区域 */ }
                <div className="tabs-content">
                    {
                        React.Children.map(this.props.children,( element,index )=>{
                            return(
                                <div className={ "tabs-content-item "+(index == this.state.currentIndex ? "tabs-content-item-action " : "") } >{ element.props.children }</div>
                            )
                        })
                    }
                </div>
            </div>
        )
    }
}



class TabItem extends React.Component{
  constructor(props) {
    super(props);
    
  }
  render() {
    return (
        <div {...props} >
          {props.children}
        </div>

    )
  }
}

Tabs.TabItem = TabItem;

