import React from 'react'
import PropTypes from 'prop-types'

export default class Tag extends React.Component {
  
  static propTypes = {
    type:PropTypes.string,
    remove:PropTypes.bool,
  };

  constructor(props) {
    super(props);
    
    this.typeEnum = {
      "default":"yt-label",
      "message":"yt-label label-message",
      "succeed":"yt-label label-succeed",
      "warning":"yt-label label-warning",
      "error":"yt-label label-error",
    }
    this.state={display: false}

  }

  onClick(e){
    this.props.onClick && this.props.onClick(e)
  }
  render(){
    let {type, remove} = this.props;
    let {display} = this.state;
    let className = this.typeEnum[type] || this.typeEnum["default"];

    return (
      <span className={className} >
      {this.props.children}
        {
          remove ? <span className="icon-delete" onClick={this.onClick.bind(this)}></span> : null
        }
      </span>
    )
  }

  
}


