import React from 'react'

import PIROS from '../index';

function example(){
  return <div>
    <PIROS.Button size="lg">
      大按钮 lg  1232131221
    </PIROS.Button>
    <br/>
    <PIROS.Button size="sm">
      小按钮 sm
    </PIROS.Button>
    <br/>
    <PIROS.Button size="lg" loading={true}>
      加载中...
    </PIROS.Button>
    <br/>
    <PIROS.Button size="lg" disabled={true}>
      禁用按钮
    </PIROS.Button>
    <br/>
    <PIROS.Button size="lg"  secondary={true}>
      次级按钮
    </PIROS.Button>

    

  </div>
}


function params(){

  let dataSource = [
    {
      key:"size",
      type:"string",
      "default":"sm",
      mark:"可选值 lg, sm"
    },
    {
      key:"disabled",
      type:"bool",
      "default":"false",
      mark:"是否禁用按钮"
    },
    {
      key:"loading",
      type:"bool",
      "default":"false",
      mark:"是否加载中"
    },
    {
      key:"secondary",
      type:"bool",
      "default":"false",
      mark:"是否为次级按钮"
    }
    
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}  columns={columns} />;
  
}

function code(){
  return `
    import {Button} from 'react-piros'
    
    <Button size="lg">
      大按钮 lg  1232131221
    </Button>

    <Button size="sm">
      小按钮 sm
    </Button>

    <Button size="lg" loading={true}>
      加载中...
    </Button>

    <Button size="lg" disabled={true}>
      禁用按钮
    </Button>

    <Button size="lg"  secondary={true}>
      次级按钮
    </Button>
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}