import React from 'react'

import PIROS from '../index'


function example() {
  let onChange =(checked) => {
    console.log("checked:",checked)
    this.setState({
      checked:checked
    })
  }

  let onChangeGroup =(checked) => {
    console.log("checked:",checked)
    this.setState({
      checkedList:checked
    })
  }
  let {checked, checkedList} = this.state;
  if (checked === undefined) checked = true;
  if (checkedList === undefined) checkedList = ['2'];

  return <div>
      <PIROS.CheckBox onChange={onChange} checked={checked} label="选择"/>
    <br/>
    <br/>
    <PIROS.CheckBoxGroup options={[{label:"选择一",value:"1"},{label:"选择二",value:"2"},{label:"选择三",value:"3"}]} onChange={onChangeGroup} checked={checkedList} disabled={["2"]}/>
    </div>
}


function params() {

  let dataSource = [
    {
      key: "checked",
      type: "bool",
      "default": "false",
      mark: "总条数"
    },
    {
      key: "disabled",
      type: "bool",
      "default": "false",
      mark: ""
    },
    {
      key: "label",
      type: "String",
      "default": "",
      mark: "label"
    },
    {
      key: "onChange",
      type: "function",
      "default": "",
      mark: "选择变化回调，返回选中值"
    }
  ];

  let groupDataSource = [
    {
      key: "checked",
      type: "array",
      "default": "[]",
      mark: "选择值的列表"
    },
    {
      key: "disabled",
      type: "array",
      "default": "[]",
      mark: "disable选择框的列表"
    },
    {
      key: "options",
      type: "array",
      "default": "",
      mark: `选择框列表：[{label:"选择一",value:"1"},{label:"选择二",value:"2"}]`
    },
    {
      key: "onChange",
      type: "function",
      "default": "",
      mark: "选择变化回调，返回选中值列表"
    }
  ]

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <div>
      <PIROS.Table dataSource={dataSource} columns={columns}/>;
    <PIROS.Table dataSource={groupDataSource} columns={columns}/>;
    </div>

}

function code() {
  return `
   let onChange =(checked) => {
    console.log("checked:",checked)
    this.setState({
      checked:checked
    })
  }

  let onChangeGroup =(checked) => {
    console.log("checked:",checked)
    this.setState({
      checkedList:checked
    })
  }
  let {checked, checkedList} = this.state;
  if (checked === undefined) checked = true;
  if (checkedList === undefined) checkedList = ['1'];

  return <div>
      <PIROS.CheckBox onChange={onChange} checked={checked} label="选择"/>
    <br/>
    <br/>
    <PIROS.CheckBoxGroup options={[{label:"选择一",value:"1"},{label:"选择二",value:"2"}]} onChange={onChangeGroup} checked={checkedList}/>
    </div>
    `;
}

module.exports = {
  title:"CheckBox 多选框",
  example: example,
  params: params,
  code: code,
}