import React from 'react'

import PIROS from '../index'
const onChange = (e)=>{
	console.log(`onchange(${e})`)
}
function example(){
	return <div>
		<PIROS.InputNumber min={-10} max={100}  defaultValue={2} step={1} onChange={onChange}/>
    <br/>
		<br/>
		<br/>
		<br/>
		<PIROS.InputNumber onChange={onChange}/>
	</div>
}


function params(){

	let dataSource = [
		{
			key:"min",
			type:"number",
			"default":"0",
			mark:"最小值"
		},
		{
			key:"max",
			type:"number",
			"default":"无",
			mark:"最大值"
		},
		{
			key:"defaultValue",
			type:"number",
			"default":"无",
			mark:"初始化的值"
		},
		{
			key:"onChange",
			type:"function",
			"default":"无",
			mark:""
		},
		{
			key:"vale",
			type:"function",
			"default":"无",
			mark:"获取input的值,设置input的值"
		},
		{
			key:"无",
			type:"无",
			"default":"无",
			mark:"支持大部分原生事件和设置"
		},


	];

	let columns = [
		{
			title:"参数",
			key:"key"
		},
		{
			title:"类型",
			key:"type"
		},
		{
			title:"默认值",
			key:"default"
		},
		{
			title:"说明",
			key:"mark"
		}
	];

	return <PIROS.Table dataSource={dataSource}  columns={columns} />;

}

function code(){

	return `
const onChange = (e)=>{
	console.log("onchange")
}
<PIROS.InputNumber min={1} max={10}  defaultValue={2} step={1} onChange={onChange}/>
    `;
}

module.exports = {
	example:example,
	params:params,
	code:code,
}