import React from 'react'

import PIROS, {Layout} from '../index';


function example(){
  return <div>整体布局</div>
}


function params(){
  let dataSource = [
    {
      key:"title",
      type:"string",
      "default":"PIROS",
      mark:"标题"
    },
    {
      key:"isShowSide",
      type:"bool",
      "default":"true",
      mark:"是否显示侧边栏"
    }
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}  columns={columns} />;
}

function code(){
  return `
      import {Layout,Menu} from 'react-piros'
      let {Side,Context} = Layout;


      let menus = {
        title:"General",
        key:"General",
        list:[
          {
            title:"Index",
            component:IndexDOC,
            href:"/Index"
          }
        ]
      };

      <Layout title="title" >
        <Side>
          <Menu 
            dataSource={menus}
            selectedKeys={["General"]}
          />
        </Side>
        <Context>
          Hello world
        </Context>
      </Layout>
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}