import React from 'react'


import PIROS, {Menu} from '../index';

function example(){


  return <div>
    <Menu
      dataSource={
        [
           {
              title:"栏目1",
              key:"m1",
              list:[
                { 
                  title:"sub1",
                  key:"sub1"
                }
              ]
           },
           {
              title:"栏目2",
              key:"m2",
              list:[
                { 
                  title:"sub2",
                  key:"sub2"
                }
              ]
           } 
        ]
      }
      openKeys={["m2"]}
      defaultOpenKeys ={["m1"]}
      defaultSelectedKeys ={["sub2"]}
      onSelect = {(menu)=>{
        console.log(menu)
      }}
    />
  </div>
}


function params(){

  let dataSource = [
    {
      key:"dataSource",
      type:"Array",
      defaultValue:"[ItemSource,ItemSource]",
      mark:"数组"
    },
    {
      key:"defaultOpenKeys",
      type:"Array",
      defaultValue:"[]",
      mark:"默认打开的菜单key"
    },
    {
      key:"defaultSelectedKeys",
      type:"Array",
      defaultValue:"[]",
      mark:"默认选中的菜单key, 目前只支持单选，未来可能支持多选"
    },
    {
      key:"onSelect",
      type:"func",
      defaultValue:"(key, item, event)=>{}",
      mark:"菜单被选中的时候出发"
    }
  ];
  let dataSource2 = [
    {
      key:"title",
      type:"String",
      defaultValue:"",
      mark:"[可选]显示名"
    },
    {
      key:"href",
      type:"String",
      defaultValue:"",
      mark:"[可选]链接地址"
    },
    {
      key:"key",
      type:"String",
      defaultValue:"",
      mark:"[必选]key值必须"
    },
    {
      key:"list",
      type:"Array",
      defaultValue:"[ItemSource,ItemSource]",
      mark:"[可选]二级菜单"
    },
    
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"defaultValue"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];
  return <div>
    <h3>dataSource</h3>
    <PIROS.Table dataSource={dataSource}  columns={columns} />
    <h3>ItemSource</h3>
    <PIROS.Table dataSource={dataSource2}  columns={columns} />
  </div>;

}

function code(){
  return `
      <Menu
        dataSource={
          [
             {
                title:"栏目1",
                key:"m1",
                list:[
                  { 
                    title:"sub1",
                    key:"sub1"
                  }
                ]
             },
             {
                title:"栏目2",
                key:"m2",
                list:[
                  { 
                    title:"sub2",
                    key:"sub2"
                  }
                ]
             } 
          ]
        }
        openKeys={["m2"]}
        defaultOpenKeys ={["m1"]}
        defaultSelectedKeys ={["sub2"]}
        onSelect = {(menu)=>{
          console.log(menu)
        }}
      />
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}