import React from 'react'

import PIROS from '../index'
function example(){
	const info = function () {
		PIROS.message.info("This is a message of info")
	};
	const success = function () {
		PIROS.message.success('This is a message of success');
	};

	const error = function () {
		PIROS.message.error('This is a message of error,set timeout =1000ms',1000,'ww');
	};

	const warning = function () {
		PIROS.message.warning('This is message of warning',1000,()=>{
			console.log('回调函数onClose')
		});
	};

	const loading = function () {
		PIROS.message.loading('This is message of warning');
	}

	return <div>
		<PIROS.Button size="sm" onClick={info}>
			普通提示框
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={success}>
			success
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={error} >
			error
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={warning}>
			waring
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={loading}>
			loading
		</PIROS.Button>
		<br/>
	</div>
}


function params(){

	let dataSource = [
		{
			key:"content",
			type:"string",
			"default":"无",
			mark:"显示的内容"
		},
		{
			key:"timeout",
			type:"int",
			"default":"3000",
			mark:"自动关闭的延时，单位毫秒"
		},
		{
			key:"onClose",
			type:"function",
			"default":"无",
			mark:"关闭时触发的回调函数"
		},


	];

	let columns = [
		{
			title:"参数",
			key:"key"
		},
		{
			title:"类型",
			key:"type"
		},
		{
			title:"默认值",
			key:"default"
		},
		{
			title:"说明",
			key:"mark"
		}
	];

	return <PIROS.Table dataSource={dataSource}  columns={columns} />;

}

function code(){
	return `
  	const info = function () {
			PIROS.message.info("This is a message of info")
		};
		const success = function () {
			PIROS.message.success('This is a message of success');
		};
	
		const error = function () {
			PIROS.message.error('This is a message of error,set timeout =1000ms',1000);
		};
	
		const warning = function () {
			PIROS.message.warning('This is message of warning',1000,()=>{
				console.log('回调函数onClose')
			});
		};
	
		const loading = function () {
			PIROS.message.loading('This is message of warning');
		}
		<PIROS.Button size="sm" onClick={info}>
			普通提示框
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={success}>
			success
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={error} >
			error
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={warning}>
			warning
		</PIROS.Button>
		<br/>
		<PIROS.Button size="sm"  secondary={true} onClick={loading}>
			loading
		</PIROS.Button>
			<br/>
    `;
}

module.exports = {
	example:example,
	params:params,
	code:code,
}