import React from 'react'

import PIROS from '../index'


function example() {
  let simpleOkHandle = () => {
    this.setState({
      simpleDisplay:false,
    })
  }

  let simpleCancelHandle = () => {
    this.setState({
      simpleDisplay:false,
    })
  }

  let simpleClick = () => {
    this.setState({
      simpleDisplay:true
    })
  }

  let loadingOkHandle = () => {
    this.setState({
      loading: true
    })
    setTimeout(()=>{
      this.setState({
        loadingDisplay:false,
        loading: false
      })
    }, 1000)
  }

  let loadingCancelHandle = () => {
    this.setState({
      loadingDisplay:false,
    })
  }

  let loadingClick = () => {
    this.setState({
      loadingDisplay:true
    })
  }

  let {loadingDisplay, simpleDisplay, loading} = this.state;
  if (loadingDisplay === undefined) loadingDisplay = false
  if (simpleDisplay === undefined) simpleDisplay = false

  return <div>
    <PIROS.Button onClick={simpleClick} >simple</PIROS.Button>
    <br/>
    <PIROS.Button onClick={loadingClick} >loading</PIROS.Button>
    <PIROS.Modal title={"Modal"} enterClick={true} display={simpleDisplay} onOk={simpleOkHandle} onCancel={simpleCancelHandle}>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
    </PIROS.Modal>
    <PIROS.Modal title={"Modal"} display={loadingDisplay} loading={loading} onOk={loadingOkHandle} onCancel={loadingCancelHandle} maskClick={true} style={{width:"200px"}}>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
    </PIROS.Modal>
  </div>
}


function params() {

  let dataSource = [
    {
      key: "display",
      type: "bool",
      "default": "false",
      mark: "是否显示"
    },
    {
      key: "title",
      type: "string",
      "default": "",
      mark: "显示title"
    },
    {
      key: "onOk",
      type: "func",
      "default": "",
      mark: "确定按钮点击方法"
    },
    {
      key: "onCancel",
      type: "func",
      "default": "",
      mark: "取消按钮点击方法"
    },
    {
      key: "loading",
      type: "bool",
      "default": "false",
      mark: "true时,按钮disable,确定按钮变加载中"
    },
    {
      key: "okButtonText",
      type: "string",
      "default": "确定",
      mark: "确定按钮文字"
    },
    {
      key: "cancelButtonText",
      type: "string",
      "default": "取消",
      mark: "取消按钮文字"
    },
    {
      key: "cancelButton",
      type: "bool",
      "default": "true",
      mark: "显示取消按钮"
    },
    {
      key: "footer",
      type: "null|dom",
      "default": "取消和确定按钮",
      mark: "自定义footer"
    },
    {
      key: "maskClick",
      type: "bool",
      "default": "false",
      mark:"点击蒙板触发onCancel方法，loading为true时失效"
    },
    {
      key: "enterClick",
      type: "bool",
      "default": "false",
      mark:"回车时执行props.onOk方法"
    },
    {
      key: "style",
      type: "css object",
      "default": "",
      mark: "样式，作用在modal-content上"
    }
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
  let simpleOkHandle = () => {
    this.setState({
      simpleDisplay:false,
    })
  }

  let simpleCancelHandle = () => {
    this.setState({
      simpleDisplay:false,
    })
  }

  let simpleClick = () => {
    this.setState({
      simpleDisplay:true
    })
  }
  let {simpleDisplay} = this.state;
  if (simpleDisplay === undefined) simpleDisplay = false

  return <div>
    <PIROS.Button onClick={simpleClick} >simple</PIROS.Button>
    <PIROS.Modal title={"Modal"} display={simpleDisplay} onOk={simpleOkHandle} onCancel={simpleCancelHandle}>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
    </PIROS.Modal>
  </div>
  
  
  

  let loadingOkHandle = () => {
    // loading设置为true, 完成loading的操作后display
    this.setState({
      loading: true
    })
    setTimeout(()=>{
      this.setState({
        loadingDisplay:false,
        loading: false
      })
    }, 1000)
  }

  let loadingCancelHandle = () => {
    // 隐藏
    this.setState({
      loadingDisplay:false,
    })
  }

  let loadingClick = () => {
    // 显示Modal
    this.setState({
      loadingDisplay:true
    })
  }

  let {loadingDisplay, loading} = this.state;
  if (loadingDisplay === undefined) loadingDisplay = false

  return <div>
    <PIROS.Button onClick={loadingClick} >loading</PIROS.Button>
    <PIROS.Modal title={"Modal"} display={loadingDisplay} loading={loading} onOk={loadingOkHandle} onCancel={loadingCancelHandle} maskClick＝{true} style={{width:"200px"}} >
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
      <p>aaaaaaaaaaa</p>
    </PIROS.Modal>
  </div>
    `;
}

module.exports = {
  title:"Modal 对话框",
  example: example,
  params: params,
  code: code,
}