import React from 'react'

import PIROS from '../index'


function example() {
  let onChange = function(index, pageSize) {
    console.log("currentPage:",index, " pageSize:",pageSize)
  }

  return <PIROS.Pagination total={200} defaultCurrent={2} pageSize={20} onChange={onChange}/>
}


function params() {

  let dataSource = [
    {
      key: "total",
      type: "number",
      "default": "0",
      mark: "总条数"
    },
    {
      key: "defaultCurrent",
      type: "number",
      "default": "1",
      mark: "首次渲染默认页码"
    },
    {
      key: "current",
      type: "number",
      "default": "-",
      mark: "当前页数"
    },
    {
      key: "pageSize",
      type: "number",
      "default": "10",
      mark: "每页条数"
    },
    {
      key: "onChange",
      type: "function",
      "default": "",
      mark: "页码变化回调函数"
    },
    {
      key: "maxShowPage",
      type: "number",
      "default": "5",
      mark: "中间显示页面数"
    },
    {
      key: "hideJumper",
      type: "",
      "default": "false",
      mark: "默认不隐藏快速跳转"
    }
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
  let onChange = function(index, pageSize) {
    console.log("toPage:",index, " pageSize:",pageSize)
  }

  return <PIROS.Pagination total={2000} defaultCurrent={1} onChange={this.onChange.bind(this)}></PIROS.Pagination>
    `;
}

module.exports = {
  title:"Pagination 分页",
  example: example,
  params: params,
  code: code,
}