import React from 'react';

import {Table, Popconfirm} from '../index'

function example() {
  const renderContent = (
    <div>
      <div style={{backgroundColor: "#ccc"}}>苟利国家生死以</div>
      <div style={{backgroundColor: "#ddd"}}>岂因祸福避趋之</div>
      <div style={{backgroundColor: "#eee"}}>+1s</div>
    </div>
  );
  return <div>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="top"
    >
      <button style={{margin: '5px'}}>上方弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="bottom"
    >
      <button style={{margin: '5px'}}>下方弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="left"
    >
      <button style={{margin: '5px'}}>左侧弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="right"
    >
      <button style={{margin: '5px'}}>右侧弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="top"
      visible={true}
    >
      <button style={{margin: '5px'}}>默认展现</button>
    </Popconfirm>
  </div>
}


function params() {
  let dataSource = [
    {
      key: "title",
      type: "string",
      "default": "默认为空",
      mark: "气泡卡片标题，title为空时无标题栏"
    },
    {
      key: "direction",
      type: "string",
      "default": "默认为top",
      mark: "弹出方向，可选参数: left | right | top | bottom 默认为top"
    },
    {
      key: "content",
      type: "object",
      "default": "默认为空div",
      mark: "传入你要渲染的主内容部分"
    },
    {
      key: "visible",
      type: "bool",
      "default": "默认为false",
      mark: "默认显示或隐藏"
    },
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
  const renderContent = (
    <div>
      <div style={{backgroundColor: "#ccc"}}>苟利国家生死以</div>
      <div style={{backgroundColor: "#ddd"}}>岂因祸福避趋之</div>
      <div style={{backgroundColor: "#eee"}}>+1s</div>
    </div>
  );

  <div>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="top"
    >
      <button style={{margin: '5px'}}>上方弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="bottom"
    >
      <button style={{margin: '5px'}}>下方弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="left"
    >
      <button style={{margin: '5px'}}>左侧弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="right"
    >
      <button style={{margin: '5px'}}>右侧弹出</button>
    </Popconfirm>
    <Popconfirm
      content={renderContent}
      title="标题内容"
      direction="top"
      visible={true}
    >
      <button style={{margin: '5px'}}>默认展现</button>
    </Popconfirm>
  </div>
    `;
}

module.exports = {
  example: example,
  params: params,
  code: code,
}