import React from 'react'

import PIROS from '../index'

function example() {
  return <div>
    <PIROS.Progress progress={0} />
    <PIROS.Progress progress={30} />
    <PIROS.Progress progress={50} />
    <PIROS.Progress progress={80} type="error" />
    <PIROS.Progress progress={100} type="success" />
  </div>
}


function params(){

  let dataSource = [
    {
      key:"progress",
      type:"number",
      default:"0",
      mark:"进度条的进度值"
    },
    {
      key:"type",
      type:"string",
      default:"\"\"",
      mark:"进度条类型, 可选值error, success"
    }
    
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}  columns={columns} />;
  
}

function code(){
  return `
    <PIROS.Progress progress={0} />
    <PIROS.Progress progress={30} />
    <PIROS.Progress progress={50} />
    <PIROS.Progress progress={80} type="error" />
    <PIROS.Progress progress={100} type="success" />
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}