import React from 'react'

import PIROS from '../index'

function example() {
  const onChange = (e) => {
    console.log("onchange", e)
  }
  const RadioChange = (e) => {
    console.log("RadioChange", e)
  }
  return <div>
    <PIROS.Radio name="1" defaultChecked value={1}>Radio</PIROS.Radio>
    <PIROS.Radio name="1" checked value={2}>A</PIROS.Radio>
    <PIROS.Radio disabled value={1}>Radio</PIROS.Radio>
    <br/>
    <br/>
    <PIROS.RadioGruop defaultValue={3} onChange={onChange}>
      <PIROS.Radio value={1} disabled>A</PIROS.Radio>
      <PIROS.Radio value={2} onChange={RadioChange}>B</PIROS.Radio>
      <PIROS.Radio value={3}>C</PIROS.Radio>
      <PIROS.Radio value={4}>D</PIROS.Radio>
    </PIROS.RadioGruop>
    <br/>
    <PIROS.RadioGruop defaultValue={1} onChange={onChange}>
      <PIROS.Radio value={1} disabled>A</PIROS.Radio>
      <PIROS.Radio value={2} onChange={RadioChange}>B</PIROS.Radio>
      <PIROS.Radio value={3}>C</PIROS.Radio>
      <PIROS.Radio value={4}>D</PIROS.Radio>
    </PIROS.RadioGruop>
  </div>
}


function params() {

  let dataSource = [
    {
      key: "defaultChecked",
      type: "bool",
      "default": "false",
      mark: "默认选中状态"
    },
    {
      key: "disabled",
      type: "bool",
      "default": "false",
      mark: "是否禁用"
    },
    {
      key: "onChange",
      type: "function",
      "default": "无",
      mark: "选中状态改变回调函数"
    },
    {
      key: "checked",
      type: "bool",
      "default": "无",
      mark: "用ref.checked可以获取选中状态"
    },
    {
      key: "value",
      type: "string",
      "default": "无",
      mark: "用ref.value可以获取被选中的radio的值，或者RadioGruop中被选中的值"
    },


  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
    const onChange = (e)=>{
      console.log("onchange")
    }
    const RadioChange = (e)=>{
      console.log("RadioChange")
    }

		<PIROS.Radio name="1"  defaultChecked value={1}>Radio</PIROS.Radio>
		<PIROS.Radio name="1" checked value={2}>A</PIROS.Radio>
		<PIROS.Radio disabled value={1}>Radio</PIROS.Radio>
		<br/>
		<br/>
		<PIROS.RadioGruop defaultValue={3} onChange={onChange}>
			<PIROS.Radio value={1} disabled >A</PIROS.Radio>
			<PIROS.Radio value={2}  onChange={RadioChange}>B</PIROS.Radio>
			<PIROS.Radio value={3}>C</PIROS.Radio>
			<PIROS.Radio value={4}>D</PIROS.Radio>
		</PIROS.RadioGruop>
	</div>
    `;
}

module.exports = {
  example: example,
  params: params,
  code: code,
}