import React from 'react'

import PIROS from '../index'



function example(){

  let dataSourceList = [
    "1111", "1234", "2222", "2345", "54321"
  ]

  let itemSourceList = [
    {text:"1111",value:"1"},
    {text:"1234", value:"2"},
    {text:"2222", value:"3"},
    {text:"2345", value:"4"},
    {text:"54321", value:"5"}
  ]


  let {dataSource} = this.state;
  let onChange = (value)=>{
    let dataSource = dataSourceList.filter((item)=>{return item.indexOf(value) >= 0});
    this.setState({dataSource:dataSource})
  };

  let {itemDataSource} = this.state;
  let onItemChange = (value)=>{
    value = value.text || value;
    let itemDataSource = itemSourceList.filter((data)=>{return data.text.indexOf(value) >= 0});
    this.setState({itemDataSource:itemDataSource})
  };

  let onItemSelect = (item)=>{
    this.setState({itemDataSource:[item]})
  };

  return <div>
    <div style={{display:"inline-block"}}>
      <label>文本: </label>
      <PIROS.SearchInput onChange={onChange} dataSource={dataSource} defaultValue="1111" />
    </div>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <div style={{display:"inline-block"}}>
      <label>结构: </label>
      <PIROS.SearchInput onChange={onItemChange} onSelect={onItemSelect} placeholder="请输入" dataSource={itemDataSource}/>
    </div>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
    <br/>
  </div>
}



function params(){

  let dataSource = [
    {
      key:"dataSource",
      type:"array",
      "default":"[]",
      mark:"数据源,如果是对象列表，对象中需要有text字段"
    },
    {
      key:"disabled",
      type:"bool",
      "default":"false",
      mark:"是否禁用"
    },
    {
      key:"defaultValue",
      type:"string|number",
      "default":"无",
      mark:"默认值"
    },
    {
      key:"value",
      type:"string|number",
      "default":"-",
      mark:"当前值"
    },
    {
      key:"onChange",
      type:"func",
      "default":"(value, item)=>{}",
      mark:"值改变回调"
    },

  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}   columns={columns} />;

}

function code(){
  return `
  let dataSourceList = [
    "1111", "1234", "2222", "2345", "54321"
  ]


  let {dataSource} = this.state;
  let onChange = (value)=>{
    <!--请求服务器返回搜索结果-->
    let dataSource = dataSourceList.filter((item)=>{return item.indexOf(value) >= 0});
    this.setState({dataSource:dataSource})
  };

  return <div>
    <PIROS.SearchInput onChange={onChange} dataSource={dataSource} />
    <br/>
  </div>
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}