import React from 'react'

import PIROS from '../index'



function example(){

  let dataSource = [
    {
      text:"first",
      value:0
    },
    {
      text:"last",
      value:"2"
    }
  ];


  return <div>


    
    <PIROS.Select dataSource={dataSource}  onChange={(value, item)=>{ console.log(value, item) }}  placeholder={"请选择"} ></PIROS.Select><br/>
    <PIROS.Select dataSource={dataSource} value={0} ></PIROS.Select><br/>
    <PIROS.Select dataSource={dataSource} defaultValue={"2"} ></PIROS.Select><br/>
    <PIROS.Select dataSource={dataSource} disabled={true} ></PIROS.Select><br/>
    <PIROS.Select dataSource={dataSource}  disabled={false} showSearch={ true } placeholder={"请选择"} ></PIROS.Select><br/>

    
    <br/><br/>

  </div>
}



function params(){

  let dataSource = [
    {
      key:"dataSource",
      type:"array",
      "default":"[]",
      mark:"数据源"
    },
    {
      key:"disabled",
      type:"bool",
      "default":"false",
      mark:"是否禁用"
    },
    {
      key:"defaultValue",
      type:"string|number",
      "default":"无",
      mark:"默认值"
    },
    {
      key:"value",
      type:"string|number",
      "default":"-",
      mark:"当前值"
    },
    {
      key:"onChange",
      type:"func",
      "default":"(value, item)=>{}",
      mark:"值改变回调"
    },
    {
      key:"showSearch",
      type:"bool",
      "default":"false",
      mark:"是否带搜索框"
    }
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}   columns={columns} />;

}

function code(){
  return `
      import {Select} from 'react-piros'

      let dataSource = [
        {
          text:"first",
          value:"first"
        },
        {
          text:"last",
          value:"last"
        }
      ];

      <Select dataSource={dataSource}  ></Select>

      <Select dataSource={dataSource} disabled={true} ></Select>
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}