import React from 'react'

import PIROS from '../index'

function example(){
	const onChange = (e)=>{
		console.log("onchange")
	}
	return <div>
		<PIROS.Switch/>
		<br/>
		<br/>
		<PIROS.Switch defaultChecked  onChange={onChange.bind(this)}/>
		<br/>
		<br/>
		<PIROS.Switch  checked onChange={onChange.bind(this)}/>
		<br/>
		<br/>
		<PIROS.Switch defaultChecked disabled onChange={onChange.bind(this)}/>
	</div>
}


function params(){

	let dataSource = [
		{
			key:"checked",
			type:"bool",
			"default":"false",
			mark:"指定当前选中状态,用ref.checked可以获取选中状态"
		},
		{
			key:"defaultChecked",
			type:"bool",
			"default":"false",
			mark:"默认选中状态"
		},
		{
			key:"disabled",
			type:"bool",
			"default":"false",
			mark:"是否禁用"
		},
		{
			key:"onChange",
			type:"function",
			"default":"无",
			mark:"选中状态改变回调函数"
		},



	];

	let columns = [
		{
			title:"参数",
			key:"key"
		},
		{
			title:"类型",
			key:"type"
		},
		{
			title:"默认值",
			key:"default"
		},
		{
			title:"说明",
			key:"mark"
		}
	];

	return <PIROS.Table dataSource={dataSource}  columns={columns} />;

}

function code(){
	return `
const onChange = (e)=>{
	console.log("onchange")
}

<PIROS.Switch/>

<PIROS.Switch defaultChecked onChange={onChange.bind(this)}/>

<PIROS.Switch  checked onChange={onChange.bind(this)}/>

<PIROS.Switch defaultChecked disabled />
    `;
}

module.exports = {
	example:example,
	params:params,
	code:code,
}