import React from 'react'

import PIROS from '../index'
function example() {

  let dataSource = [
    {
      id:"111",
      firstName: "lu",
      lastName: "jun"
    },
    {
      id:"112",
      firstName: "gao",
      lastName: "bo"
    }
  ];

  let columns = [
    {
      title: "姓",
      key: "firstName",
    },
    {
      title: "名",
      key: "lastName",
    },
    {
      title: "全名",
      key: "fullName",
      render(text, item){
        return item.firstName + item.lastName
      }
    }
  ];

  let rowSelection = {
    type: "checkbox",
    selectedRowKeys: [1],
    onChange: (selectedRowKeys, selectedRows) => {
      console.log(selectedRowKeys, selectedRows)
    }
  }

  return <div>
    <PIROS.Button onClick={()=>{this.refs.table.reset()}}>reset</PIROS.Button>
    <br/>
    <br/>
    <PIROS.Table dataSource={dataSource} ref="table" rowKey="id" rowSelection={rowSelection} columns={columns}></PIROS.Table>
  </div>
}


function params() {

  let dataSource = [
    {
      key: "loading",
      type: "bool",
      "default": "false",
      mark: "显示加载中，只有dataSource长度为0才会显示加载中"
    },
    {
      key: "dataSource",
      type: "array",
      "default": "[]",
      mark: "数据源"
    },
    {
      key: "columns",
      type: "array",
      "default": "[]",
      mark: "表头"
    },
    {
      key: "isIndex",
      type: "bool",
      "default": "false",
      mark: "是否显示行号"
    },
    {
      key: "rowSelection",
      type: "object",
      "default": "null",
      mark: "列表可选择配置"
    }
  ];

  let dataSource2 = [
    {
      key: "type",
      type: "string",
      "default": "checkbox",
      mark: "checkbox|radio, 目前仅支持多选"
    },
    {
      key: "selectedRowKeys",
      type: "array",
      "default": "[]",
      mark: "默认选中的行的key值"
    },
    {
      key: "onChange",
      type: "func",
      "default": "(selectedRowKeys, selectedRows)={}",
      mark: "选择发生回调函数"
    }
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <div>
    <h2>Table</h2>
    <PIROS.Table dataSource={dataSource} columns={columns}/>
    <h2>rowSelection</h2>
    <PIROS.Table dataSource={dataSource2} columns={columns}/>
  </div>

}

function code() {
  return `
      let dataSource = [
        {
          key:1,
          firstName:"lu",
          lastName:"jun"
        },
        {
          key:2,
          firstName:"gao",
          lastName:"bo"
        }
      ];

      let columns = [
        {
          title:"姓",
          key:"firstName",
        },
        {
          title:"名",
          key:"lastName",
        },
        {
          title:"全名",
          key:"fullName",
          render(text, item){
            return item.firstName + item.lastName
          }
        }
      ];

      let rowSelection = {
          type:"checkbox",
          selectedRowKeys:[1],
          onChange:(selectedRowKeys, selectedRows)=>{
            console.log(selectedRowKeys, selectedRows)
          }
      }
      <div>
        <PIROS.Button onClick={()=>{this.refs.table.reset()}}>reset</PIROS.Button>
        <br/>
        <PIROS.Table dataSource={dataSource} rowSelection={rowSelection} columns={columns}></PIROS.Table>
      </div>
    `;
}

module.exports = {
  example: example,
  params: params,
  code: code,
}