import React from 'react'

import PIROS from '../index';




function example(){

  this.removeTag = (tag)=>{
    console.log("delete tag:", tag)
  }

  return <div>
    <PIROS.Tag >
      默认标签
    </PIROS.Tag>
    <PIROS.Tag type="message">
     消息标签
    </PIROS.Tag>
    <PIROS.Tag type="succeed" >
      成功标签
    </PIROS.Tag>
    <PIROS.Tag type="warning" >
      警告标签
    </PIROS.Tag>
    <PIROS.Tag type="error">
      错误标签
    </PIROS.Tag>
    <PIROS.Tag remove={true}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="message" remove={true}  onClick={()=>{this.removeTag("message")}}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="succeed"  remove={true} onClick={()=>{this.removeTag("succeed")}}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="warning" remove={true}  onClick={()=>{this.removeTag("warning")}}>
      可移除标签
    </PIROS.Tag>
    
    <PIROS.Tag type="error"  remove={true} onClick={()=>{this.removeTag("error")}}>
      可移除标签
    </PIROS.Tag>

  </div>
}


function params(){

  let dataSource = [
    {
      key:"type",
      type:"string",
      "default":"",
      mark:"可选值 message succeed warning error"
    },
    {
      key:"remove",
      type:"bool",
      "default":"false",
      mark:"可移除标签"
    }
    
  ];

  let columns = [
    {
      title:"参数",
      key:"key"
    },
    {
      title:"类型",
      key:"type"
    },
    {
      title:"默认值",
      key:"default"
    },
    {
      title:"说明",
      key:"mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource}  columns={columns} />;
  
}

function code(){
  return `
    <PIROS.Tag >
      默认标签
    </PIROS.Tag>
    <PIROS.Tag type="message">
     消息标签
    </PIROS.Tag>
    <PIROS.Tag type="succeed" >
      成功标签
    </PIROS.Tag>
    <PIROS.Tag type="warning" >
      警告标签
    </PIROS.Tag>
    <PIROS.Tag type="error">
      错误标签
    </PIROS.Tag>
    <PIROS.Tag remove={true}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="message" remove={true}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="succeed"  remove={true}>
      可移除标签
    </PIROS.Tag>
    <PIROS.Tag type="warning" remove={true}>
      可移除标签
    </PIROS.Tag>
    
    <PIROS.Tag type="error"  remove={true}>
      可移除标签
    </PIROS.Tag>
    `;
}

module.exports = {
  example:example,
  params:params,
  code:code,
}