import React from 'react'

import {Tooltip, Table} from '../index'


function example() {

  return <div>
    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title这是向上的title"
        direction="top"
      >
        <button>向上</button>
      </Tooltip>
    </div>

    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向左的title"
        direction="left"
      >
        <button>向左</button>
      </Tooltip>
    </div>

    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向右的title"
        direction="right"
      >
        <button>向右</button>
      </Tooltip>
    </div>

    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向下的title"
        direction="bottom"
      >
        <button>向下</button>
      </Tooltip>
    </div>

    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向下的title"
        direction="bottom"
        onEnter={() => console.info('弹出')}
      >
        <button>弹出时的回调,见console</button>
      </Tooltip>
    </div>

    <div style={{margin: '10px', display: 'inline-block'}}>
      <Tooltip
        title="这是向下的title"
        direction="bottom"
        onLeave={() => console.info('离开')}
      >
        <button>消失时的回调,见console</button>
      </Tooltip>
    </div>
  </div>
}


function params() {

  let dataSource = [
    {
      key: "title",
      type: "string",
      "default": "默认为空",
      mark: "弹出的文字(必传)"
    },
    {
      key: "direction",
      type: "string",
      "default": "right",
      mark: "可选参数: left | right | top | bottom 默认为right"
    },
    {
      key: "onEnter",
      type: "function",
      "default": "默认为空",
      mark: "触发弹窗时的回调函数"
    },
    {
      key: "onLeave",
      type: "function",
      "default": "默认为空",
      mark: "弹窗消失时的回调函数"
    }
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
    <PIROS.Tooltip
        title="这里是弹窗的提示信息"
        direction="right"
        onLeave={() => console.log('随便一个函数对象')}
        onEnter={() => console.log('随便一个函数对象')}
    >
        <button>这个也是必须的。。。</button>
    </PIROS.Tooltip>
  `;
}

module.exports = {
  example: example,
  params: params,
  code: code,
}