import React from 'react'

import PIROS from '../index'


function example() {
  let onLoad = (response, e) => {
    let {fileList} = this.state;
    if (response && response.data && response.data.name){
      fileList.push({
        name:response.data.name,
        href:`http://image.yuantutech.com/${response.data.path}${response.data.name}`
      })
    }
    this.setState({
      fileList
    })
    console.log("onLoad response:", response, e)
  }


  let onError = (res, e) => {
    console.log("onError :", res)
  }

  let onProcess = (e) => {
    console.log("onProcess",e)
  }

  let removeFile = (file) =>{
    let {fileList} = this.state;
    console.log(fileList,"remove file:", file)
    if (fileList.indexOf(file) > -1){
      fileList.splice(fileList.indexOf(file), 1)
    }
    this.setState({
      fileList
    })
  }

  let onLoadBase64 = (data, e) =>{
    let {Base64List} = this.state;
    Base64List.push(data)
    this.setState({
      Base64List
    })
  }

  let removeBase64 = (data) =>{
    let {Base64List} = this.state;
    console.log(Base64List,"remove file:", data)
    if (Base64List.indexOf(data) > -1){
      Base64List.splice(Base64List.indexOf(data), 1)
    }
    this.setState({
      Base64List
    })
  }


  if (this.state.fileList === undefined){
    this.state.fileList=['http://image.yuantutech.com/user/d7846bb575a7f446364306052bd2292c-503-444.jpg']
  }
  if (this.state.Base64List === undefined){
    this.state.Base64List=[]
  }

  return <div>
    <PIROS.Upload action="http://tps.yuantutech.com/upload" onLoad={onLoad} onError={onError}
                  listType="picture" size={{width:750}} showProgress={true}
                  fileList={this.state.fileList} removeFile={removeFile}  accept="image"/>
    <br/>
    <br/>
    <br/>
    <br/>
    <PIROS.Upload action="base64" onLoad={onLoadBase64}  fileList={this.state.Base64List}
                  listType="picture" removeFile={removeBase64}  accept="image"/>
  </div>
}


function params() {

  let dataSource = [
    {
      key: "action",
      type: "string",
      "default": "",
      mark: "必传，图片上传地址(当action值==='base64'时，返回base64)"
    },
    {
      key: "desc",
      type: "string",
      "default": "",
      mark: "显示提示"
    },
    {
      key: "onLoad",
      type: "func",
      "default": "",
      mark: "上传成功的回调"
    },
    {
      key: "onProgress",
      type: "func",
      "default": "",
      mark: "onProgress"
    },
    {
      key: "showProgress",
      type: "bool",
      "default": "false",
      mark: "是否显示上传进度条"
    },
    {
      key: "onError",
      type: "func",
      "default": "",
      mark: "error回调"
    },
    {
      key: "accept",
      type: "string",
      "default": "",
      mark: "上传文件类型限制"
    },
    {
      key: "customRequest",
      type: "func",
      "default": "",
      mark: "自定义上传方法"
    },
    {
      key: "disabled",
      type: "bool",
      "default": "false",
      mark: "是否失效"
    },
    {
      key: "withCredentials",
      type: "bool",
      "default": "true",
      mark: "是否携带cookie（使用CORS时）"
    },
    {
      key: "fileList",
      type: "array",
      "default": "[]",
      mark: "文件列表['a.png',{name:'b.png', href:'http://xxx/b.png'}]，对象时点击可打开新页面查看图片"
    },
    {
      key: "removeFile",
      type: "func",
      "default": "",
      mark: "删除文件回调"
    }
  ];

  let columns = [
    {
      title: "参数",
      key: "key"
    },
    {
      title: "类型",
      key: "type"
    },
    {
      title: "默认值",
      key: "default"
    },
    {
      title: "说明",
      key: "mark"
    }
  ];

  return <PIROS.Table dataSource={dataSource} columns={columns}/>;

}

function code() {
  return `
    let onLoad = (response, e) => {
      let {fileList} = this.state;
      if (response && response.data && response.data.name){
        fileList.push({
          name:response.data.name,
          href:\`http://image.yuantutech.com/\${response.data.path}\${response.data.name}\`
      })
    }
    this.setState({
      fileList
    })
    console.log("onLoad response:", response, e)
    }


    let onError = (res, e) => {
      console.log("onError :", res)
    }

    let onProcess = (e) => {
      console.log("onProcess",e)
    }

    let removeFile = (file) =>{
      let {fileList} = this.state;
      console.log(fileList,"remove file:", file)
      if (fileList.indexOf(file) > -1){
        fileList.splice(fileList.indexOf(file), 1)
      }
      this.setState({
        fileList
      })
    }

    let onLoadBase64 = (data, e) =>{
      let {Base64List} = this.state;
      Base64List.push(data)
      this.setState({
        Base64List
      })
    }

    let removeBase64 = (data) =>{
      let {Base64List} = this.state;
      console.log(Base64List,"remove file:", data)
      if (Base64List.indexOf(data) > -1){
        Base64List.splice(Base64List.indexOf(data), 1)
      }
      this.setState({
        Base64List
      })
    }


    if (this.state.fileList === undefined){
      this.state.fileList=['http://image.yuantutech.com/user/d7846bb575a7f446364306052bd2292c-503-444.jpg']
    }
    if (this.state.Base64List === undefined){
      this.state.Base64List=[]
    }

    return <div>
      <PIROS.Upload action="http://tps.yuantutech.com/upload" onLoad={onLoad} onError={onError} onProcess={onProcess}
                    listType="picture" size={{width:361}} fileList={this.state.fileList} removeFile={removeFile}  accept="image"/>
      <br/>
      <br/>
      <br/>
      <br/>
      <PIROS.Upload action="base64" onLoad={onLoadBase64}  fileList={this.state.Base64List}
                    listType="picture" removeFile={removeBase64}  accept="image"/>
    </div>
    `;
}

module.exports = {
  title:"Upload 上传",
  example: example,
  params: params,
  code: code,
}